Package: HTSFilter
Type: Package
Title: Filter replicated high-throughput transcriptome sequencing data
Version: 1.52.0
Date: 2020-12-04
Authors@R: c(
  person(given="Andrea", 
         family="Rau", 
         email="andrea.rau@inrae.fr", 
         role=c("cre", "aut"), 
         comment = c(ORCID = "0000-0001-6469-488X")),
  person(given="Melina",
         family="Gallopin",
         role="ctb"),
  person(given="Gilles",
         family="Celeux",
         role="ctb"),
  person(given="Florence",
         family="Jaffrézic",
         role="ctb"))
Depends: R (>= 4.0.0)
Imports: edgeR, DESeq2, BiocParallel, Biobase, utils, stats, grDevices,
        graphics, methods
Suggests: EDASeq, testthat, knitr, rmarkdown, BiocStyle
Description: This package implements a filtering procedure for
    replicated transcriptome sequencing data based on a global
    Jaccard similarity index in order to identify genes with low,
    constant levels of expression across one or more experimental
    conditions.
License: Artistic-2.0
LazyLoad: yes
biocViews: Sequencing, RNASeq, Preprocessing, DifferentialExpression,
        GeneExpression, Normalization, ImmunoOncology
RoxygenNote: 7.1.1
VignetteBuilder: knitr
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/HTSFilter
git_branch: RELEASE_3_23
git_last_commit: 40d8543
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:39:11 UTC; biocbuild
Author: Andrea Rau [cre, aut] (ORCID: <https://orcid.org/0000-0001-6469-488X>),
  Melina Gallopin [ctb],
  Gilles Celeux [ctb],
  Florence Jaffrézic [ctb]
Maintainer: Andrea Rau <andrea.rau@inrae.fr>

# HTSFilter: Data-based filtering for replicated transcriptome sequencing experiments

Authors: Andrea Rau, M&eacute;lina Gallopin, Gilles Celeux, Florence Jaffr&eacute;zic
 
High-throughput sequencing (HTS) data, such as RNA-sequencing (RNA-seq) data, are often used to conduct differential analyses, in which statistical tests are performed for each biological feature (e.g., a gene, transcript, exon) in order to identify those whose expression levels show systematic covariation with a particular condition, such as a treatment or phenotype of interest. Because hypothesis tests are performed for gene-by-gene differential analyses, the obtained *p*-values must be adjusted to correct for multiple testing. However, procedures to adjust *p*-values to control the number of detected false positives often lead to a loss of power to detect truly differentially expressed (DE) genes due to the large number of hypothesis tests performed. To reduce the impact of such procedures, independent data filters are often used to identify and remove genes that appear to generate an uninformative signal; this in turn moderates the correction needed to adjust for multiple testing. 

The *HTSFilter* package (DOI: 10.18129/B9.bioc.HTSFilter) implements a novel data-based filtering procedure based on the calculation of a similarity index among biological replicates for read counts arising from replicated transcriptome sequencing (RNA-seq) data. This technique provides an intuitive data-driven way to filter high-throughput transcriptome sequencing data and to effectively remove genes with low, constant expression levels without incorrectly removing those that would otherwise have been identified as DE. 

### Reference

Rau, A., Gallopin, M., Celeux, G., and Jaffrézic, F. (2013). Data-based filtering for replicated high-throughput transcriptome sequencing experiments. *Bioinformatics* 29(17): 2146-2152. 

### License

The *HTSFilter* package is free software; you can copy or redistribute it under the terms of the Artistic-2.0 License. This program is distributed in the hope that it will be useful, but without any warranty; without even the implied 
warranty of merchantability or fitness for a particular purpose. See the Artistic-2.0 License for more details.

A copy of the Artistic License, version 2.0, is available at https://opensource.org/licenses/Artistic-2.0.

.perConditionSimilarityIndex <-
function(data.norm.perCondition, log.s){

	countsNormLog <- log(data.norm.perCondition)
	countsNormLog_binary <- countsNormLog > log.s
	sum <- 0
	nbindiv <- ncol(countsNormLog)
	calc <- mapply(function(i,j) {
		x <- countsNormLog_binary[,i]
		y <- countsNormLog_binary[,j]
		a <- length(which(x == 1 & y == 1))
		b <- length(which(x == 1 & y == 0))
		c <- length(which(x == 0 & y == 1))
		d <- length(which(x == 0 & y == 0))
		## Sanity check
		if(sum(c(a,b,c,d)) != length(x) & sum(c(a,b,c,d)) != length(y)) {
			stop("Something's wrong.")
		}
		a / (a+b+c)
		},
		rep(1:(nbindiv), times = c((nbindiv-1):0)),
		unlist(lapply(2:nbindiv, function(x) seq(x,nbindiv))) )
	## AR (1/15/2013): use mean rather than sum in case of unbalanced experiments
	return(mean(calc))
}


.HTSFilterBackground <-
function(data, conds, s.min, s.max, s.len,
	loess.span, normalization,  plot, plot.name,  parallel, BPPARAM) {

	## Sanity checks: replicated data?
	if(min(table(conds) == 1)) {
		stop("All conditions must have at least TWO replicates.")
	}
	if(s.min <= 0) stop("s.min must be > 0.");
	if(s.min > s.max) stop(paste(sQuote(s.min), "must be <", sQuote(s.max)));
	if(dim(data)[2] != length(conds)) {
		stop(paste(sQuote(conds), " must be of length ", dim(data)[2],
		" (the number of columns of", sQuote(data), ")", sep = ""))
	}

	## Normalization (calculated on full dataset)
	norm <- normalizeData(data = data,
		normalization = normalization)
	data.norm <- norm$data.norm
	norm.factor <- norm$norm.factor

	## Calculate index for each threshold value
	s.test <- seq(log(s.min), log(s.max), length = s.len)
	## AR (1/17/2013): use mean rather than sum so max value is 1
	if(parallel == FALSE) {
	  index <- rowMeans(matrix(mapply(function(condition, s) {
	    .perConditionSimilarityIndex(data.norm.perCondition = data.norm[,which(conds == unique(conds)[condition])],
	                                 log.s = s)},
	    rep(1:length(unique(conds)), times = length(s.test)),
	    rep(s.test, each = length(unique(conds)))), ncol = length(unique(conds)),
	    byrow = TRUE))
	}
	## AR (10/10/2016): add parallel functionality
	if(parallel == TRUE) {
	  tmp <- bpmapply(function(condition, s) {
	    .perConditionSimilarityIndex(data.norm.perCondition = data.norm[,which(conds == unique(conds)[condition])],
	                                 log.s = s)
	    },
	    rep(1:length(unique(conds)), times = length(s.test)),
	    rep(s.test, each = length(unique(conds))), BPPARAM=BPPARAM)
	  index <- rowMeans(matrix(unlist(tmp), ncol = length(unique(conds)), byrow=TRUE))
	}


	## Choosing s.optimal: Fit a loess curve to data
	index[which(is.nan(index) == TRUE)] <- NA
	p <- predict(loess(index ~ exp(s.test), span = loess.span),
		seq(s.min, s.max, by = 0.001))
	s.optimal <- seq(s.min, s.max, by = 0.001)[which(p == max(p, na.rm = TRUE))]
	if(plot == TRUE) {
		if(is.na(plot.name) != TRUE) pdf(plot.name, width = 6, height = 6);
		plot(exp(s.test), index, log = "x", xlab = "Threshold",
			ylab = "Global Jaccard index")
		lines(seq(s.min, s.max, by = 0.001), p, col = "blue", lwd = 2)
		points(s.optimal, max(p, na.rm = TRUE), col = "red", pch = "X", cex= 1.5)
		abline(v = s.optimal, lty = 2, col= "red")
		legend("bottomleft", pch = "X", col="red", cex = 1.25, paste("s =", s.optimal), bty = "n")
		if(is.na(plot.name) != TRUE) dev.off();
	}

	## Calculate which genes are present in at least one sample with s.optimal
	data.binary <- matrix(NA, nrow = length(conds), ncol = dim(data)[1])
	data.binary <- data.norm > s.optimal
	on <- ifelse(rowSums(data.binary) == 0, 0, 1)

	data.filter <- data[which(on == 1),]
	colnames(data.binary) <- colnames(data)
	rownames(data.binary) <- rownames(data)

	filter.results <- list(on = on, s.optimal = s.optimal, data.binary = data.binary,
		index.values = data.frame(threshold = exp(s.test), index = index),
		data.filter = data.filter, norm.factor = norm.factor)

	return(filter.results)
}


.HTSBasicFilterBackground <- function(data, method, cutoff.type="value", cutoff=10,
	length=NA, normalization) {

	## Sanity checks
	check <- method %in% c("mean", "sum", "rpkm", "variance", "cpm",
		"max", "cpm.mean", "cpm.sum", "cpm.variance", "cpm.max",
		"rpkm.mean", "rpkm.sum", "rpkm.variance", "rpkm.max")
	if(check != TRUE) stop("Only the following basic filters are currently supported:
		mean, sum, rpkm, variance, cpm, max")
	if(!is(cutoff.type, "character") & !is(cutoff.type, "numeric") &
		length(cutoff.type) != 1)
		stop(paste("cutoff.type must be equal to a numeric value, or one of the following:\n",
			dQuote("value"), dQuote("number"), dQuote("quantile")))

	## Normalize data
	x <- data
	norm <- normalizeData(x, normalization)
	x.norm <- norm$data.norm
	norm.factor <- norm$norm.factor

	## Prep filtering criteria
	if(method == "mean") crit <- apply(x.norm, 1, mean);
	if(method == "sum") crit <- apply(x.norm, 1, sum);
	if(method == "variance") crit <- apply(x.norm, 1, var);
	if(method == "max") crit <- apply(x.norm, 1, max);
	if(method == "cpm" | method == "cpm.mean" | method == "cpm.sum" |
		method == "cpm.variance" | method == "cpm.max") {
		if(normalization != "TMM") message("Note that TMM normalization is used for cpm filter.")
		dge <- DGEList(counts=x)
		dge <- calcNormFactors(dge)
		crit <- .cpmDGEList(dge, normalized.lib.sizes=TRUE, log=FALSE, prior.count=0.25)
		if(method == "cpm.mean") crit <- apply(crit, 1, mean)
		if(method == "cpm.sum") crit <- apply(crit, 1, sum)
		if(method == "cpm.variance") crit <- apply(crit, 1, var)
		if(method == "cpm.max") crit <- apply(crit, 1, max)
	}
	if(method == "rpkm" | method == "rpkm.mean" | method == "rpkm.sum" |
		method == "rpkm.variance" | method == "rpkm.max") {
		if(is.vector(length) == FALSE | length(length) != nrow(x))
			stop(paste("length needed for rpkm filter"))
		if(normalization != "TMM") message("Note that TMM normalization is used for rpkm filter.")
		dge <- DGEList(counts=x)
		dge <- calcNormFactors(dge)
		crit <- .rpkmDGEList(dge, gene.length=length, normalized.lib.sizes=TRUE, log=FALSE, prior.count=0.25)
		if(method == "rpkm.mean") crit <- apply(crit, 1, mean)
		if(method == "rpkm.sum") crit <- apply(crit, 1, sum)
		if(method == "rpkm.variance") crit <- apply(crit, 1, var)
		if(method == "rpkm.max") crit <- apply(crit, 1, max)
	}

	## Apply filters
	if(method == "mean" | method == "sum" | method == "variance" | method == "max" |
		method == "cpm.mean" | method == "cpm.sum" | method == "cpm.variance" |
		method == "cpm.max" | method == "rpkm.mean" | method == "rpkm.sum" |
		method == "rpkm.variance" | method == "rpkm.max") {
		if(is(cutoff.type, "numeric"))
			stop(paste("cutoff.type must be equal to one of the following:\n",
			dQuote("value"), dQuote("number"), dQuote("quantile")))

		if(cutoff.type == "value") {
			on.index <- which(crit > cutoff)
		}
		if(cutoff.type == "number") {
			o <- order(crit, decreasing=TRUE)
			on.index <- which(o <= cutoff)
		}
		if(cutoff.type == "quantile") {
			q <- quantile(crit, cutoff, na.rm=TRUE)
			on.index <- which(crit > q)
		}
	}
	if(method == "cpm" | method == "rpkm") {
		if(is(cutoff.type, "character"))
			stop(paste("cutoff.type must be numeric."))
		on.index <- rowSums(crit>cutoff) >= cutoff.type
		on.index <- which(on.index == TRUE)
	}
	if(method =="rpkm.mean" | method == "rpkm.sum" | method == "rpkm.variance" |
		method == "rpkm.max") {
		no.length <- which(is.na(crit) == TRUE)
		on.index <- sort(c(on.index, no.length))
	}
	if(method == "rpkm") {
		no.length <- which(is.na(crit[,1]) == TRUE)
		on.index <- sort(c(on.index, no.length))
	}

	## Return filter results
	filteredData <- x; removedData <- NA;
	if(length(on.index) > 0) filteredData <- x[on.index,]
	if(length(on.index) < nrow(x)) removedData <- x[-on.index,]
	on <- rep(0, nrow(x)); on[on.index] <- 1
	filter.results <- list(filteredData =  filteredData,
		on = on, normFactor = norm.factor, removedData = removedData,
		filterCrit = crit)
	return(filter.results)
}


## RPKM function taken from edgeR version 3.1.3
.rpkmDGEList <- function(x, gene.length, normalized.lib.sizes=TRUE, log=FALSE,
    prior.count = 0.25)
{
    y <- .cpmDGEList(x, normalized.lib.sizes=normalized.lib.sizes,
        log=log, prior.count = prior.count)
    if (log)
        y - log2(gene.length) + log2(1000)
    else y/(gene.length/1000)
}

## CPM functions taken from edgeR version 3.1.3
.cpmDGEList <- function (x, normalized.lib.sizes=TRUE, log=FALSE, prior.count=0.25)
{
    lib.size <- x$samples$lib.size
    if (normalized.lib.sizes)
        lib.size <- lib.size * x$samples$norm.factors
    .cpm(x$counts, lib.size=lib.size, log=log, prior.count=prior.count)
}
.cpm <- function (x, lib.size=NULL, log=FALSE, prior.count=0.25)
{
    x <- as.matrix(x)
    if (is.null(lib.size))
        lib.size <- colSums(x)
    if (log) {
        prior.count.scaled <- lib.size/mean(lib.size) * prior.count
        lib.size <- lib.size + prior.count.scaled
    }
    lib.size <- 1e-06 * lib.size
    if (log)
        log2(t((t(x) + prior.count.scaled)/lib.size))
    else t(t(x)/lib.size)
}

#' Implement basic filters for transcriptome sequencing data.
#' 
#' Implement a variety of basic filters for transcriptome sequencing data.
#' 
#' This function implements a basic filter for high-throughput sequencing data for a variety of filter types: 
#' mean, sum, RPKM, variance, CPM, maximum, mean CPM values, the sum of CPM values, the variance of CPM 
#' values, maximum CPM value, mean RPKM values, the sum of RPKM values, the variance of RPKM values, or 
#' the maximum RPKM value. The filtering criteria used may be for a given cutoff value, a number of genes, 
#' or a given quantile value.
#' 
#' 
#' @export
#' 
#' @param x A numeric matrix or data.frame representing the counts of dimension (\emph{g} x \emph{n}), 
#' for \emph{g} genes in \emph{n} samples, a \code{DGEList} object, a 
#' \code{DGEExact} object, a \code{DGEGLM} object, a \code{DGELRT} object, or a \code{DESeqDataSet} object.
#' 
#' @param method  Basic filtering method to be used: \dQuote{mean}, \dQuote{sum}, \dQuote{rpkm}, 
#' \dQuote{variance}, \dQuote{cpm}, \dQuote{max}, \dQuote{cpm.mean}, \dQuote{cpm.sum}, \dQuote{cpm.variance}, 
#' \dQuote{cpm.max}, \dQuote{rpkm.mean}, \dQuote{rpkm.sum}, \dQuote{rpkm.variance}, or \dQuote{rpkm.max}
#' 
#' @param cutoff.type Type of cutoff to be used: a numeric value indicating the number of samples to be 
#' used for filtering (when \code{method} = \dQuote{cpm} or \dQuote{rpkm}), or one of \dQuote{value}, 
#' \dQuote{number}, or \dQuote{quantile}
#' 
#' @param cutoff Cutoff to be used for chosen filter
#' 
#' @param length Optional vector of length \emph{n} containing the lengths of each gene in \code{x}; 
#' optional except in the case of \code{method} = \dQuote{rpkm}
#' 
#' @param normalization Normalization method to be used to correct for differences in library sizes, with 
#' choices  \dQuote{TMM} (Trimmed Mean of M-values), \dQuote{DESeq} (normalization method proposed in the
#' DESeq package), \dQuote{pseudo.counts} (pseudo-counts obtained via quantile-quantile normalization in 
#' the edgeR package, only available for objects of class \code{DGEList} and \code{DGEExact}), and 
#' \dQuote{none} (to be used only if user is certain no normalization is required, or if data have already 
#' been pre-normalized by an alternative method)
#' 
#' @param pAdjustMethod The method used to adjust p-values, see \code{?p.adjust}
#' 
#' @param ... Additional optional arguments
#' 
#' @return 
#' \itemize{
#'  \item{filteredData }{An object of the same class as \code{x} containing the data that passed the filter}
#' 
#'  \item{on }{A binary vector of length \emph{g}, where 1 indicates a gene with normalized expression
#'   greater than the optimal filtering threshold \code{s.optimal} in at least one sample (irrespective of 
#'   condition labels), and 0 indicates a gene with normalized expression less than or equal to the optimal 
#'   filtering threshold in all samples}
#' 
#'  \item{normFactor }{A vector of length \emph{n} giving the estimated library sizes estimated by the
#'   normalization method specified in \code{normalization}}
#' 
#'  \item{removedData }{A matrix containing the filtered data}
#' 
#'  \item{filterCrit }{A vector or matrix containing the criteria used to perform filtering}
#'  }
#' 
#' @references 
#' R. Bourgon, R. Gentleman, and W. Huber. (2010) Independent filtering increases detection power for high-
#' throughput experiments. \emph{PNAS} \bold{107}(21):9546-9551.
#' 
#' A. Rau, M. Gallopin, G. Celeux, F. Jaffrezic (2013). Data-based filtering 
#' for replicated high-throughput transcriptome sequencing experiments. \emph{Bioinformatics},
#' doi: 10.1093/bioinformatics/btt350.
#' 
#' @author 
#' Andrea Rau, Melina Gallopin, Gilles Celeux, and Florence Jaffrezic
#' 
#' @example /inst/examples/HTSBasicFilter.R
#' 
#' @keywords methods
#' @importMethodsFrom DESeq2 counts
#' @importFrom stats loess predict quantile var
#' @importFrom grDevices pdf dev.off
#' @importFrom graphics plot lines points abline legend
#' @importFrom edgeR DGEList calcNormFactors
setGeneric(
  name = "HTSBasicFilter",
  def = function(x, ...) 
    {standardGeneric("HTSBasicFilter")}
)


#' @rdname HTSBasicFilter
## matrix
setMethod(
  f= "HTSBasicFilter",
  signature = signature(x="matrix"),
  definition = function(x, method, cutoff.type="value", cutoff=10, 
                        length=NA, normalization=c("TMM", "DESeq", "none")) 
  {
    normalization <- match.arg(normalization)
    data <- x
    
    ## Run filter
    filter <- .HTSBasicFilterBackground(data=data, method=method,
                                        cutoff.type=cutoff.type, cutoff=cutoff, length=length,
                                        normalization=normalization)
    
    ## Return various results
    filter.results <- list(filteredData =  filter$filteredData,
                           on = filter$on, normFactor = filter$normFactor,
                           removedData = filter$removedData, filterCrit = filter$filterCrit)
    return(filter.results)
  }
)

#' @rdname HTSBasicFilter
## data.frame
setMethod(
  f= "HTSBasicFilter",
  signature = signature(x="data.frame"),
  definition = function(x, method, cutoff.type="value", cutoff=10, 
                        length=NA, normalization=c("TMM", "DESeq", "none")) 
    
  {
    normalization <- match.arg(normalization)
    data <- as.matrix(x)
    if(is.character(data) == TRUE) {
      stop("Character values detected in data.frame x.\nPlease check that ID names are not included in one of the columns.")
    }
    
    ## Run filter
    filter <- .HTSBasicFilterBackground(data=data, method=method,
                                        cutoff.type=cutoff.type, cutoff=cutoff, length=length,
                                        normalization=normalization)
    
    ## Return various results
    filter.results <- list(filteredData =  filter$filteredData,
                           on = filter$on, normFactor = filter$normFactor,
                           removedData = filter$removedData, filterCrit = filter$filterCrit)
    return(filter.results)
  }
)



#' @rdname HTSBasicFilter
## DGEList
setMethod(
  f="HTSBasicFilter",
  signature = signature(x="DGEList"),
  definition = function(x, method, cutoff.type="value", cutoff=10, 
                        length=NA, normalization=c("TMM", "DESeq", "pseudo.counts", "none")) 
  {
    
    if(!require(edgeR)) {
      stop("edgeR library must be installed.")
    }
    if(is.null(x$common.dispersion) == FALSE & is.null(x$tagwise.dispersion == TRUE)) {
      stop("Filtering must be performed either before calling estimateCommonDisp, or after calling estimateTagwiseDisp.")
    }
    
    normalization <- match.arg(normalization)
    data <- x$counts
    conds <- x$samples$group
    if(normalization == "pseudo.counts") {
      if(is.null(x$pseudo.counts) == TRUE) {
        stop(paste("To use pseudo.counts for filtering, you must first call estimateCommonDisp."))
      }
      data <- x$pseudo.counts
      normalization <- "none"
    }
    
    ## Run filter
    filter <- .HTSBasicFilterBackground(data=data, method=method,
                                        cutoff.type=cutoff.type, cutoff=cutoff, length=length,
                                        normalization=normalization)
    on <- filter$on
    on.index <- which(on == 1)
    filteredData <- x
    
    ## Create a new DGEList
    filteredData <- x
    filteredData$counts <- x$counts[on.index,]
    filteredData$pseudo.counts <- x$pseudo.counts[on.index,]
    ## logCPM removed April 3, 2015 because no longer included in DGEList
    ## filteredData$logCPM <- x$logCPM[on.index]
    filteredData$tagwise.dispersion <- x$tagwise.dispersion[on.index]
    ## Added August 8, 2013: thanks to Marie-Laure Endale for catching this one!
    filteredData$genes <- x$genes[on.index]
    filteredData$AveLogCPM <- x$AveLogCPM[on.index]
    filteredData$trended.dispersion <- x$trended.dispersion[on.index]
    filteredData$offset <- x$offset[on.index,]
    
    ## Reset library sizes if filtering before estimating dispersion parameters 
    if(is.null(x$common.dispersion) == TRUE) {
      filteredData$samples$lib.size = colSums(filteredData$counts)
    }
    
    ## Return various results
    nf <- filter$norm.factor
    if(normalization == "pseudo.counts") nf <- "pseudo.counts"
    
    filter.results <- list(filteredData =  filteredData,
                           on = filter$on, normFactor = nf,
                           removedData = filter$removedData, filterCrit = filter$filterCrit)
    
    return(filter.results)
  }
)


#' @rdname HTSBasicFilter
## DGEExact
setMethod(
  f="HTSBasicFilter",
  signature = signature(x="DGEExact"),
  definition = function(x, method, cutoff.type="value", cutoff=10, 
                        length=NA, normalization=c("TMM", "DESeq", "pseudo.counts", "none")) 
  {
    
    if(!require(edgeR)) {
      stop("edgeR library must be installed.")
    }
    normalization <- match.arg(normalization)
    data <- DGEList$counts
    conds <- DGEList$samples$group
    if(normalization == "pseudo.counts") {
      if(is.null(DGEList$pseudo.counts) == TRUE) {
        stop(paste("To use pseudo.counts for filtering, you must first call estimateCommonDisp."))
      }
      data <- DGEList$pseudo.counts
      normalization <- "none"
    }
    
    ## Run filter
    filter <- .HTSBasicFilterBackground(data=data, method=method,
                                        cutoff.type=cutoff.type, cutoff=cutoff, length=length,
                                        normalization=normalization)
    on <- filter$on
    on.index <- which(on == 1) 
    
    ## Create a new DGEExact
    filteredData <- x
    filteredData$table <- x$table[on.index,]
    filteredData$genes <- x$genes[on.index]
    
    ## Return various results
    nf <- filter$norm.factor
    if(normalization == "pseudo.counts") nf <- "pseudo.counts"
    filter.results <- list(filteredData =  filteredData,
                           on = filter$on, normFactor = nf,
                           removedData = filter$removedData, filterCrit = filter$filterCrit)
    return(filter.results)
  }
)

#' @rdname HTSBasicFilter
## DGEGLM
setMethod(
  f="HTSBasicFilter",
  signature = signature(x="DGEGLM"),
  definition = function(x, method, cutoff.type="value", cutoff=10, 
                        length=NA, normalization=c("TMM", "DESeq", "none"))
  {
    if(!require(edgeR)) {
      stop("edgeR library must be installed.")
    }
    normalization <- match.arg(normalization)
    data <- x$counts
    
    ## Run filter
    filter <- .HTSBasicFilterBackground(data=data, method=method,
                                        cutoff.type=cutoff.type, cutoff=cutoff, length=length,
                                        normalization=normalization)
    on <- filter$on
    on.index <- which(on == 1) 
    
    ## Create a new DGEGLM
    filteredData <- x
    filteredData$counts <- x$counts[on.index,]
    filteredData$coefficients <- x$coefficients[on.index,]
    filteredData$df.residual <- x$df.residual[on.index]
    filteredData$deviance <- x$deviance[on.index]
    filteredData$genes <- x$genes[on.index]
    filteredData$dispersion <- x$dispersion[on.index]
    filteredData$weights <- x$weights[on.index]
    filteredData$fitted.values <- x$fitted.values[on.index,]
    filteredData$abundance <- x$abundance[on.index]
    filteredData$offset <- x$offset[on.index,]
    ## Added August 8, 2013: thanks to Marie-Laure Endale for catching this one!
    filteredData$AveLogCPM <- x$AveLogCPM[on.index]
    ## Added April 3, 2015
    filteredData$unshrunk.coefficients <- x$unshrunk.coefficients[on.index,]
    
    ## Return various results
    nf <- filter$norm.factor
    filter.results <- list(filteredData =  filteredData,
                           on = filter$on, normFactor = nf,
                           removedData = filter$removedData, filterCrit = filter$filterCrit)
    return(filter.results)
  }
)

#' @rdname HTSBasicFilter
## DGELRT
setMethod(
  f="HTSBasicFilter",
  signature = signature(x="DGELRT"),
  definition = function(x, method, cutoff.type="value", cutoff=10, 
                        length=NA, normalization=c("TMM", "DESeq", "none"))
  {
    
    if(!require(edgeR)) {
      stop("edgeR library must be installed.")
    }
    normalization <- match.arg(normalization)
    data <- x$counts
    
    ## Run filter
    filter <- .HTSBasicFilterBackground(data=data, method=method,
                                        cutoff.type=cutoff.type, cutoff=cutoff, length=length,
                                        normalization=normalization)
    on <- filter$on
    on.index <- which(on == 1) 
    
    ## Create a new DGELRT
    filteredData <- x
    filteredData$table <- x$table[on.index,]
    filteredData$coefficients <- x$coefficients[on.index,]
    ## Added April 3, 2015:
    filteredData$unshrunk.coefficients <- x$unshrunk.coefficients[on.index,]
    filteredData$df.test <- x$df.test[on.index]
    ## Removed April 3, 2015:
    ## filteredData$genes <- x$genes[on.index]
    ## filteredData$weights <- x$weights[on.index,]
    ## filteredData$abundance <- x$abundance[on.index]
    filteredData$df.residual <- x$df.residual[on.index]
    filteredData$dispersion <- x$dispersion[on.index]
    filteredData$fitted.values <- x$fitted.values[on.index,]
    filteredData$deviance <- x$deviance[on.index]
    filteredData$offset <- x$offset[on.index,]
    ## Added August 8, 2013: thanks to Marie-Laure Endale for catching this one!
    filteredData$AveLogCPM <- x$AveLogCPM[on.index]
    
    ## Return various results
    nf <- filter$norm.factor
    filter.results <- list(filteredData =  filteredData,
                           on = filter$on, normFactor = nf,
                           removedData = filter$removedData, filterCrit = filter$filterCrit)
    return(filter.results)
  }
)


#' @rdname HTSBasicFilter
## DESeqDataSet
setMethod(
  f= "HTSBasicFilter",
  signature = signature(x="DESeqDataSet"),
  definition = function(x, method, cutoff.type="value", cutoff=10,
                        length=NA, normalization=c("DESeq", "TMM", "none"), pAdjustMethod="BH")
  {
    if(!require(DESeq2)) {
      stop("DESeq2 library must be installed.")
    }          
    normalization <- match.arg(normalization)
    data <- counts(x, normalized=FALSE)
    
    ## Run filter
    filter <- .HTSBasicFilterBackground(data=data, method=method,
                                        cutoff.type=cutoff.type, cutoff=cutoff, length=length,
                                        normalization=normalization)
    on <- filter$on
    on.index <- which(on == 1) 
    filteredData <- x[on.index,]
    
    ## April 3, 2015: remove this as p-values are not adjusted in DESeqDataSet			
    #		if(length(colnames(mcols(filteredData))) > 0) {
    #                ## Re-adjust p-values, if they exist
    #                nm <- strsplit(colnames(mcols(filteredData)), split="_", fixed=TRUE)
    #                Waldindex <- which(unlist(lapply(nm, function(yy) yy[1]))=="WaldPvalue")
    #                LRTindex <- which(unlist(lapply(nm,  function(yy) yy[1]))=="LRTPvalue")
    #                # Wald p-values
    #                if(length(Waldindex) > 0 ) {
    #                  for(j in Waldindex) {
    #                    look <- substr(colnames(mcols(filteredData))[j], 12, 100)
    #                    find <- which(substr(colnames(mcols(filteredData)), 12+3, 100) == look)
    #                    find <- find[which(find > j)]
    #                    mcols(filteredData)[,find] <- p.adjust(mcols(filteredData)[,j], method=pAdjustMethod)
    #                  }
    #                }
    #                # LRT p-values
    #                if(length(LRTindex) > 0 ) {
    #                  for(j in LRTindex) {
    #                    look <- substr(colnames(mcols(filteredData))[j], 11, 100)
    #                    find <- which(substr(colnames(mcols(filteredData)), 11+3, 100) == look)
    #                    find <- find[which(find > j)]
    #                    mcols(filteredData)[,find] <- p.adjust(mcols(filteredData)[,j], method=pAdjustMethod)
    #                  }
    #                }
    #		}
    
    ## Return various results
    filter.results <- list(filteredData = filteredData,
                           on = filter$on, normFactor = filter$norm.factor,
                           removedData = data[which(filter$on == 0),], filterCrit = filter$filterCrit)
    return(filter.results)
  }
)

#' Filter replicated high-throughput transcriptome sequencing data
#'
#' This package implements a filtering procedure for replicated
#' transcriptome sequencing data based on a global Jaccard similarity index in
#' order to identify genes with low, constant levels of expression across one or
#' more experimental conditions.
#'
#' \tabular{ll}{ Package: \tab HTSFilter\cr Type: \tab Package\cr Version:
#' \tab 1.31.1\cr Date: \tab 2020-11-26\cr License: \tab Artistic-2.0 \cr LazyLoad:
#' \tab yes\cr }
#'
#' @name HTSFilter-package
#' @aliases HTSFilter-package
#' @docType package
#' @author Andrea Rau, Melina Gallopin, Gilles Celeux, and Florence Jaffrezic
#'
#' Maintainer: Andrea Rau <\url{andrea.rau@inrae.fr}>
#' @references
#' R. Bourgon, R. Gentleman, and W. Huber. (2010) Independent filtering increases detection power for high-
#' throughput experiments. \emph{PNAS} \bold{107}(21):9546-9551.
#'
#' P. Jaccard (1901). Etude comparative de la distribution
#' orale dans une portion des Alpes et des Jura.
#' \emph{Bulletin de la Societe Vaudoise des Sciences Naturelles}, \bold{37}:547-549.
#'
#' A. Rau, M. Gallopin, G. Celeux, F. Jaffrezic (2013). Data-based filtering
#' for replicated high-throughput transcriptome sequencing experiments. \emph{Bioinformatics},
#' doi: 10.1093/bioinformatics/btt350.
#'
#' @keywords package
#' @example /inst/examples/HTSFilter-package.R
#' @import Biobase
NULL




#' RNA-seq data from humans in Sultan et al. (2008)
#'
#' This dataset represents RNA-seq data from humans in two conditions (Ramos B cell line and HEK293T), with two biological replicates per condition.
#' The ExpressionSet was downloaded from the ReCount online resource.
#'
#' @name sultan
#' @docType data
#' @references \url{data_blah.com}
#' @usage data(sultan)
#' @keywords datasets
#' @format An ExpressionSet named \code{sultan.eset} containing the phenotype data and
#' expression data for the Sultan et al. (2008) experiment. Phenotype data may be
#' accessed using the \code{pData} function, and expression data may be accessed
#' using the \code{exprs} function.
#' @return Object of class \sQuote{ExpressionSet}. Matrix of counts can be accessed after
#' loading the \sQuote{Biobase} package and calling \code{exprs(sultan))}.
#' @source ReCount online resource (http://bowtie-bio.sourceforge.net/recount).
#' @references
#' A. C. Frazee, B. Langmead, and J. T. Leek. ReCount: a multi-experiment resource
#' of analysis-ready RNA-seq gene count datasets. BMC Bioinformatics, 12(449), 2011.
#'
#' M. Sultan, M. H. Schulz, H. Richard, A. Magen, A. Klingenhoff, M. Scherf, M. Seifert,
#' T. Borodina, A. Soldatov, D. Parkhomchuk, D. Schmidt, S. O'Keefe, S. Haas,
#' M. Vingron, H. Lehrach, and M. L. Yaspo. A global view of gene activity and alternative
#' splicing by deep sequencing of the human transcriptome. Science, 15(5891):956-60, 2008.
NULL

#' Calculate data-based filtering threshold for replicated transcriptome sequencing data.
#'
#' Calculate a data-based filtering threshold for replicated transcriptome
#' sequencing data through the pairwise Jaccard similarity index between pairs
#' of replicates within each experimental condition.
#'
#' The Jaccard similarity index, which measures the overlap of two sets, is calculated as follows.
#' Given two binary vectors, each of length \emph{n}, we define the following values:
#'   \itemize{
#'       \item \emph{a} = the number of attributes with a value of 1 in both vectors
#'       \item \emph{b} = the number of attributes with a value of 1 in the first vector and 0 in the second
#'       \item \emph{c} = the number of attributes with a value of 0 in the first vector and 1 in the second
#'       \item \emph{d} = the number of attributes with a value of 0 in both vectors
#'         }
#' We note that all attributes fall into one of these four quantities, so \eqn{a+b+c+d=n}. Given these
#' quantities, we may calculate the Jaccard similarity index between the two vectors as follows:
#'   \deqn{J = \frac{a}{a+b+c}.}{J = a/(a+b+c).}
#'
#' @aliases
#' HTSFilter
#' HTSFilter-methods
#' HTSFilter,matrix-method
#' HTSFilter,data.frame-method
#' HTSFilter,DGEList-method
#' HTSFilter,DGEExact-method
#' HTSFilter,DGEGLM-method
#' HTSFilter,DGELRT-method
#' HTSFilter,DESeqDataSet-method
#'
#' @export
#'
#' @param x A numeric matrix or data.frame representing the counts of dimension (\emph{g} x \emph{n}),
#' for \emph{g} genes in \emph{n} samples, a \code{DGEList} object, a
#' \code{DGEExact} object, a \code{DGEGLM} object, a \code{DGELRT} object, or a \code{DESeqDataSet} object.
#'
#' @param conds  Vector of length \emph{n} identifying the experimental condition of each of the \emph{n} samples; required when sQuote(x)
#' is a numeric matrix. In the case of objects of class \code{DGEList},
#' \code{DGEExact}, \code{DGEGLM}, \code{DGELRT}, or \code{DESeqDataSet}, the design matrix is automatically
#’ detected from the object; if an alternative design should be used, this may optionally be provided.
#’ Note that in multi-factor designs in which one or more combinations of factors are unreplicated, the bonds
#’ vector may be used to specify only the primary factor of interest for use in HTSFilter.
#'
#' @param s.min Minimum value of filtering threshold to be considered, with default value equal to 1
#'
#' @param s.max Maximum value of filtering threshold to be considered, with default value equal to 200
#'
#' @param s.len Length of sequence of filtering thresholds to be considered (from \code{s.min} to \code{s.max})
#'   for the calculation of the global similarity index
#'
#' @param loess.span Span of the loess curve to be fitted to the filtering thresholds and corresponding global similarity
#'   indices, with default value equal to 0.3
#'
#' @param normalization Normalization method to be used to correct for differences in library sizes, with
#' choices  \dQuote{TMM} (Trimmed Mean of M-values), \dQuote{DESeq} (normalization method proposed in the
#' DESeq package), \dQuote{pseudo.counts} (pseudo-counts obtained via quantile-quantile normalization in
#' the edgeR package, only available for objects of class \code{DGEList} and \code{DGEExact}), and
#' \dQuote{none} (to be used only if user is certain no normalization is required, or if data have already
#' been pre-normalized by an alternative method)
#'
#' @param pAdjustMethod The method used to adjust p-values, see \code{?p.adjust}
#'
#' @param plot If \dQuote{TRUE}, produce a plot of the calculated global similarity indices against the
#' filtering threshold with superimposed loess curve
#'
#' @param plot.name  If \code{plot} = \dQuote{TRUE}, the name of the PDF file to be saved to the current working directory.
#'   If \code{plot.name} = NA, the plot is drawn in the current window.
#'
#' @param DGEList Object of class DGEList, to be used when filtering objects of class DGEExact
#'
#' @param DGEGLM Object of class DGEGLM, to be used when filtering objects of class DGELRT
#'
#' @param parallel If \code{FALSE}, no parallelization. If \code{TRUE}, parallel
#' execution using BiocParallel (see next argument \code{BPPARAM}). A note on running
#' in parallel using BiocParallel: it may be advantageous to remove large, unneeded objects
#' from the current R environment before calling the function, as it is possible that R's
#' internal garbage collection will copy these files while running on worker nodes.
#'
#' @param BPPARAM Optional parameter object passed internally to \code{bplapply} when
#' \code{parallel=TRUE}. If not specified, the parameters last registered with \code{register}
#' will be used.
#' @param ... Additional optional arguments
#'
#'
#' @return
#' \itemize{
#'  \item{filteredData }{An object of the same class as \code{x} containing the data that passed the filter}
#'
#'  \item{on }{A binary vector of length \emph{g}, where 1 indicates a gene with normalized expression
#'   greater than the optimal filtering threshold \code{s.optimal} in at least one sample (irrespective of
#'   condition labels), and 0 indicates a gene with normalized expression less than or equal to the optimal
#'   filtering threshold in all samples}
#'
#'  \item{s }{The optimal filtering threshold as identified by the global similarity index}
#'
#'  \item{indexValues }{A matrix of dimension (\code{s.len} x 2) giving the tested filtering thersholds and the
#'  corresponding global similarity indices. Note that the threshold values are equally spaced on the \emph{log}
#'  scale, and thus unequally spaced on the count scale (i.e., we test more threshold values at very low levels
#'  of expression, and fewer at very high levels of expression).}
#'
#'  \item{normFactor }{A vector of length \emph{n} giving the estimated library sizes estimated by the
#'   normalization method specified in \code{normalization}}
#'
#'  \item{removedData }{A matrix containing the filtered data}
#' }
#'
#' @references
#' R. Bourgon, R. Gentleman, and W. Huber. (2010) Independent filtering increases detection power for high-
#' throughput experiments. \emph{PNAS} \bold{107}(21):9546-9551.
#'
#' P. Jaccard (1901). Etude comparative de la distribution
#' orale dans une portion des Alpes et des Jura.
#' \emph{Bulletin de la Societe Vaudoise des Sciences Naturelles}, \bold{37}:547-549.
#'
#' A. Rau, M. Gallopin, G. Celeux, F. Jaffrezic (2013). Data-based filtering
#' for replicated high-throughput transcriptome sequencing experiments. \emph{Bioinformatics},
#' doi: 10.1093/bioinformatics/btt350.
#'
#' @author
#' Andrea Rau, Melina Gallopin, Gilles Celeux, and Florence Jaffrezic
#'
#' @example /inst/examples/HTSFilter-package.R
#' @keywords methods
#' @rdname HTSFilter
#' @importFrom BiocParallel bpmapply bpparam
#' @import methods

setGeneric(
  name = "HTSFilter",
  def = function(x, ...)
    {standardGeneric("HTSFilter")}
)



#' @rdname HTSFilter
## matrix
setMethod(
  f= "HTSFilter",
  signature = signature(x="matrix"),
  definition = function(x, conds, s.min=1, s.max=200, s.len=100,
                        loess.span=0.3, normalization=c("TMM", "DESeq", "none"),
                        plot=TRUE, plot.name=NA, parallel=FALSE, BPPARAM=bpparam())

  {
    normalization <- match.arg(normalization)
    data <- x

    ## Multiple factor designs
    if(is.null(dim(conds)) == FALSE) conds <- do.call(paste, as.data.frame(conds))

    ## Run filter
    filter <- .HTSFilterBackground(data=data, conds=conds, s.min=s.min,
                                   s.max=s.max, s.len=s.len, loess.span=loess.span,
                                   normalization=normalization, plot=plot,
                                   plot.name=plot.name, parallel=parallel, BPPARAM=BPPARAM)

    filteredData <- filter$data.filter
    if(length(rownames(data))) rownames(filteredData) <- rownames(data)[which(filter$on == 1)]
    if(length(colnames(data))) colnames(filteredData) <- colnames(data)

    ## Return various results
    filter.results <- list(filteredData = filteredData,
                           on = filter$on, s = filter$s.optimal,
                           indexValues = filter$index.values, normFactor = filter$norm.factor,
                           removedData = data[which(filter$on == 0),])

    return(filter.results)
  }
)

#' @rdname HTSFilter
## data.frame
setMethod(
  f= "HTSFilter",
  signature = signature(x="data.frame"),
  definition = function(x, conds, s.min=1, s.max=200, s.len=100,
                        loess.span=0.3, normalization=c("TMM", "DESeq", "none"),
                        plot=TRUE, plot.name=NA, parallel=FALSE, BPPARAM=bpparam())

  {
    normalization <- match.arg(normalization)
    data <- as.matrix(x)
    if(is.character(data) == TRUE) {
      stop("Character values detected in data.frame x.\nPlease check that ID names are not included in one of the columns.")
    }

    ## Multiple factor designs
    if(is.null(dim(conds)) == FALSE) conds <- do.call(paste, as.data.frame(conds))

    ## Run filter
    filter <- .HTSFilterBackground(data=data, conds=conds, s.min=s.min,
                                   s.max=s.max, s.len=s.len, loess.span=loess.span,
                                   normalization=normalization, plot=plot,
                                   plot.name=plot.name, parallel=parallel, BPPARAM=BPPARAM)

    filteredData <- filter$data.filter
    if(length(rownames(data))) rownames(filteredData) <- rownames(data)[which(filter$on == 1)]
    if(length(colnames(data))) colnames(filteredData) <- colnames(data)


    ## Return various results
    filter.results <- list(filteredData =  filteredData,
                           on = filter$on, s = filter$s.optimal,
                           indexValues = filter$index.values, normFactor = filter$norm.factor,
                           removedData = data[which(filter$on == 0),])

    return(filter.results)
  }
)


#' @rdname HTSFilter
## DGEList
setMethod(
  f="HTSFilter",
  signature = signature(x="DGEList"),
  definition = function(x, s.min=1, s.max=200, s.len=100,
                        loess.span=0.3, normalization=c("TMM","DESeq","pseudo.counts","none"),
                        plot=TRUE, plot.name=NA, parallel=FALSE, BPPARAM=bpparam(), conds)
  {

    if(missing(conds)) conds <- NULL
    if(!require(edgeR)) {
      stop("edgeR library must be installed.")
    }

    if(is.null(x$common.dispersion) == FALSE & is.null(x$tagwise.dispersion == TRUE)) {
      stop("Filtering must be performed either before calling estimateCommonDisp, or after calling estimateTagwiseDisp.")
    }

    normalization <- match.arg(normalization)
    data <- x$counts
    if(!length(conds))  conds <- x$samples$group
    if(normalization == "pseudo.counts") {
      if(is.null(x$pseudo.counts) == TRUE) {
        stop(paste("To use pseudo.counts for filtering, you must first call estimateCommonDisp."))
      }
      data <- x$pseudo.counts
      normalization <- "none"
    }

    ## Run filter
    filter <- .HTSFilterBackground(data=data, conds=conds, s.min=s.min,
                                   s.max=s.max, s.len=s.len, loess.span=loess.span,
                                   normalization=normalization, plot=plot,
                                   plot.name=plot.name,  parallel=parallel, BPPARAM=BPPARAM)
    on <- filter$on
    on.index <- which(on == 1)
    filteredData <- x

    ## Create a new DGEList
    filteredData <- x
    filteredData$counts <- x$counts[on.index,]
    filteredData$pseudo.counts <- x$pseudo.counts[on.index,]
    ## logCPM removed April 3, 2015 because no longer included in DGEList
    ## filteredData$logCPM <- x$logCPM[on.index]
    filteredData$tagwise.dispersion <- x$tagwise.dispersion[on.index]
    ## Added August 8, 2013: thanks to Marie-Laure Endale for catching this one!
    filteredData$genes <- x$genes[on.index]
    filteredData$AveLogCPM <- x$AveLogCPM[on.index]
    filteredData$trended.dispersion <- x$trended.dispersion[on.index]
    filteredData$offset <- x$offset[on.index,]

    ## Reset library sizes if filtering before estimating dispersion parameters
    if(is.null(x$common.dispersion) == TRUE) {
      filteredData$samples$lib.size = colSums(filteredData$counts)
    }

    ## Return various results
    nf <- filter$norm.factor
    if(normalization == "pseudo.counts") nf <- "pseudo.counts"

    filter.results <- list(filteredData = filteredData,
                           on = filter$on, s = filter$s.optimal,
                           indexValues = filter$index.values,
                           normFactor = nf,
                           removedData = x$counts[-on.index,])

    return(filter.results)
  }
)

#' @rdname HTSFilter
## DGEExact
setMethod(
  f="HTSFilter",
  signature = signature(x="DGEExact"),
  definition = function(x, DGEList, s.min=1, s.max=200, s.len=100,
                        loess.span=0.3, normalization=c("TMM","DESeq","pseudo.counts","none"),
                        plot=TRUE, plot.name=NA, parallel=FALSE, BPPARAM=bpparam(), conds)
  {

    if(missing(conds)) conds <- NULL

    if(!require(edgeR)) {
      stop("edgeR library must be installed.")
    }
    normalization <- match.arg(normalization)
    data <- DGEList$counts
    if(!length(conds)) conds <- DGEList$samples$group
    if(normalization == "pseudo.counts") {
      if(is.null(DGEList$pseudo.counts) == TRUE) {
        stop(paste("To use pseudo.counts for filtering, you must first call estimateCommonDisp."))
      }
      data <- DGEList$pseudo.counts
      normalization <- "none"
    }

    ## Run filter
    filter <- .HTSFilterBackground(data=data, conds=conds, s.min=s.min,
                                   s.max=s.max, s.len=s.len, loess.span=loess.span,
                                   normalization=normalization, plot=plot,
                                   plot.name=plot.name,  parallel=parallel, BPPARAM=BPPARAM)
    on <- filter$on
    on.index <- which(on == 1)

    ## Create a new DGEExact
    filteredData <- x
    filteredData$table <- x$table[on.index,]
    filteredData$genes <- x$genes[on.index]

    ## Return various results
    nf <- filter$norm.factor
    if(normalization == "pseudo.counts") nf <- "pseudo.counts"
    filter.results <- list(filteredData = filteredData,
                           on = filter$on, s = filter$s.optimal,
                           indexValues = filter$index.values,
                           normFactor = nf,
                           removedData = x$counts[-on.index,])

    return(filter.results)
  }
)



#' @rdname HTSFilter
## DGEGLM
setMethod(
  f="HTSFilter",
  signature = signature(x="DGEGLM"),
  definition = function(x, s.min=1, s.max=200, s.len=100,
                        loess.span=0.3, normalization=c("TMM","DESeq","none"),
                        plot=TRUE, plot.name=NA, parallel=FALSE, BPPARAM=bpparam(), conds)
  {

    if(missing(conds)) conds <- NULL

    if(!require(edgeR)) {
      stop("edgeR library must be installed.")
    }
    normalization <- match.arg(normalization)
    data <- x$counts
    if(!length(conds)) {
      conds <- x$design
      ## Remove intercept if present
      if(colnames(conds)[1] == "(Intercept)") conds <- conds[,-1]
      ## Multiple factor designs
      if(is.null(dim(conds)) == FALSE) conds <- do.call(paste, as.data.frame(conds))
    }

    ## Run filter
    filter <- .HTSFilterBackground(data=data, conds=conds, s.min=s.min,
                                   s.max=s.max, s.len=s.len, loess.span=loess.span,
                                   normalization=normalization, plot=plot,
                                   plot.name=plot.name,  parallel=parallel, BPPARAM=BPPARAM)
    on <- filter$on
    on.index <- which(on == 1)

    ## Create a new DGEGLM
    filteredData <- x
    filteredData$counts <- x$counts[on.index,]
    filteredData$coefficients <- x$coefficients[on.index,]
    filteredData$df.residual <- x$df.residual[on.index]
    filteredData$deviance <- x$deviance[on.index]
    filteredData$genes <- x$genes[on.index]
    filteredData$dispersion <- x$dispersion[on.index]
    filteredData$weights <- x$weights[on.index]
    filteredData$fitted.values <- x$fitted.values[on.index,]
    filteredData$abundance <- x$abundance[on.index]
    filteredData$offset <- x$offset[on.index,]
    ## Added August 8, 2013: thanks to Marie-Laure Endale for catching this one!
    filteredData$AveLogCPM <- x$AveLogCPM[on.index]
    ## Added April 3, 2015
    filteredData$unshrunk.coefficients <- x$unshrunk.coefficients[on.index,]

    ## Return various results
    nf <- filter$norm.factor
    filter.results <- list(filteredData = filteredData,
                           on = filter$on, s = filter$s.optimal,
                           indexValues = filter$index.values,
                           normFactor = nf,
                           removedData = x$counts[-on.index,])

    return(filter.results)
  }
)

#' @rdname HTSFilter
## DGELRT
setMethod(
  f="HTSFilter",
  signature = signature(x="DGELRT"),
  definition = function(x, DGEGLM, s.min=1, s.max=200, s.len=100,
                        loess.span=0.3, normalization=c("TMM","DESeq","none"),
                        plot=TRUE, plot.name=NA, parallel=FALSE, BPPARAM=bpparam(), conds)
  {

    if(missing(conds)) conds <- NULL

    if(!require(edgeR)) {
      stop("edgeR library must be installed.")
    }
    normalization <- match.arg(normalization)
    data <- DGEGLM$counts
    if(!length(conds)) {
      conds <- x$design
      ## Remove intercept if present
      if(colnames(conds)[1] == "(Intercept)") conds <- conds[,-1]
      ## Multiple factor designs
      if(is.null(dim(conds)) == FALSE) conds <- do.call(paste, as.data.frame(conds))
    }

    ## Run filter
    filter <- .HTSFilterBackground(data=data, conds=conds, s.min=s.min,
                                   s.max=s.max, s.len=s.len, loess.span=loess.span,
                                   normalization=normalization, plot=plot,
                                   plot.name=plot.name,  parallel=parallel, BPPARAM=BPPARAM)
    on <- filter$on
    on.index <- which(on == 1)

    ## Create a new DGELRT
    filteredData <- x
    filteredData$table <- x$table[on.index,]
    filteredData$coefficients <- x$coefficients[on.index,]
    ## Added April 3, 2015:
    filteredData$unshrunk.coefficients <- x$unshrunk.coefficients[on.index,]
    filteredData$df.test <- x$df.test[on.index]
    ## Removed April 3, 2015:
    ## filteredData$genes <- x$genes[on.index]
    ## filteredData$weights <- x$weights[on.index,]
    ## filteredData$abundance <- x$abundance[on.index]
    filteredData$df.residual <- x$df.residual[on.index]
    filteredData$dispersion <- x$dispersion[on.index]
    filteredData$fitted.values <- x$fitted.values[on.index,]
    filteredData$deviance <- x$deviance[on.index]
    filteredData$offset <- x$offset[on.index,]
    ## Added August 8, 2013: thanks to Marie-Laure Endale for catching this one!
    filteredData$AveLogCPM <- x$AveLogCPM[on.index]

    ## Return various results
    nf <- filter$norm.factor
    filter.results <- list(filteredData = filteredData,
                           on = filter$on, s = filter$s.optimal,
                           indexValues = filter$index.values,
                           normFactor = nf,
                           removedData = x$counts[-on.index,])

    return(filter.results)
  }
)



#' @rdname HTSFilter
## DESeqDataSet
setMethod(
  f= "HTSFilter",
  signature = signature(x="DESeqDataSet"),
  definition = function(x, s.min=1, s.max=200, s.len=100,
                        loess.span=0.3, normalization=c("DESeq", "TMM", "none"),
                        plot=TRUE, plot.name=NA, pAdjustMethod="BH",
                        parallel=FALSE, BPPARAM=bpparam(), conds)

  {
    if(missing(conds)) conds <- NULL

    if(!require(DESeq2)) {
      stop("DESeq2 library must be installed.")
    }
    normalization <- match.arg(normalization)
    data <- counts(x, normalized=FALSE)

    ## November 14, 2017: adjust for more complicated designs in DESeq2
    ## especially when not all columns of colData are used in design
    ## Thanks to Stephanie Durand for finding this bug!
    if(!length(conds)) {
      condsMat <- x@colData
      des <- x@design
      desfactors <- strsplit(as.character(x@design)[-1], split=" + ", fixed=TRUE)[[1]]
      indfactors <- strsplit(as.character(x@design)[-1], split=" * ", fixed=TRUE)[[1]]
      desfactors <- unique(c(desfactors, indfactors))
      index <- which(colnames(condsMat) %in% desfactors)
      condsMat <- condsMat[,index]
      ## Multiple factor designs
      if(is.null(dim(condsMat)) == FALSE) condsMat <- do.call(paste, as.data.frame(condsMat))
      conds <- condsMat
    }
    if(min(table(conds)) < 2) {
      print(table(conds))
      stop(paste("Watch out! One of the combinations of factors in your design has a single replicate.
Use the conds argument to specify a condition vector in which all levels are replicated (for instance, a single factor)"))
    }

    ## Run filter
    filter <- .HTSFilterBackground(data=data, conds=conds, s.min=s.min,
                                   s.max=s.max, s.len=s.len, loess.span=loess.span,
                                   normalization=normalization, plot=plot,
                                   plot.name=plot.name,  parallel=parallel, BPPARAM=BPPARAM)
    on <- filter$on
    on.index <- which(on == 1)
    filteredData <- x[on.index,]

    ## April 3, 2015: remove this as p-values are not adjusted in DESeqDataSet
    #		if(length(colnames(mcols(filteredData))) > 0) {
    #                ## Re-adjust p-values, if they exist
    #                nm <- strsplit(colnames(mcols(filteredData)), split="_", fixed=TRUE)
    #                Waldindex <- which(unlist(lapply(nm, function(yy) yy[1]))=="WaldPvalue")
    #                LRTindex <- which(unlist(lapply(nm,  function(yy) yy[1]))=="LRTPvalue")
    #               # Wald p-values
    #                if(length(Waldindex) > 0 ) {
    #                  for(j in Waldindex) {
    #                    look <- substr(colnames(mcols(filteredData))[j], 12, 100)
    #                    find <- which(substr(colnames(mcols(filteredData)), 12+3, 100) == look)
    #                    find <- find[which(find > j)]
    #                    mcols(filteredData)[,find] <- p.adjust(mcols(filteredData)[,j], method=pAdjustMethod)
    #                  }
    #                }
    #                # LRT p-values
    #                if(length(LRTindex) > 0 ) {
    #                  for(j in LRTindex) {
    #                    look <- substr(colnames(mcols(filteredData))[j], 11, 100)
    #                    find <- which(substr(colnames(mcols(filteredData)), 11+3, 100) == look)
    #                    find <- find[which(find > j)]
    #                    mcols(filteredData)[,find] <- p.adjust(mcols(filteredData)[,j], method=pAdjustMethod)
    #                  }
    #                }
    #		}

    ## Return various results
    filter.results <- list(filteredData = filteredData,
                           on = filter$on, s = filter$s.optimal,
                           indexValues = filter$index.values, normFactor = filter$norm.factor,
                           removedData = data[which(filter$on == 0),])

    return(filter.results)
  }
)

library(Biobase)
data("sultan")
conds <- pData(sultan)$cell.line
 
########################################################################
## Matrix or data.frame
########################################################################

## Filter genes with total (sum) normalized gene counts < 10
filter <- HTSBasicFilter(exprs(sultan), method="sum", cutoff.type="value", 
                        cutoff = 10)
                        
                        
########################################################################
## DGEExact
########################################################################

library(edgeR)
## Filter genes with CPM values less than 100 in more than 2 samples
dge <- DGEList(counts=exprs(sultan), group=conds)
dge <- calcNormFactors(dge)
filter <- HTSBasicFilter(dge, method="cpm", cutoff.type=2, cutoff=100)

########################################################################
## DESeq2
########################################################################

library(DESeq2)
conds <- gsub(" ", ".", conds)
dds <- DESeqDataSetFromMatrix(countData = exprs(sultan),
                             colData = data.frame(cell.line = conds),
                               design = ~ cell.line)
                             
                             
## Not run: Filter genes with mean normalized gene counts < 40% quantile
## dds <- DESeq(dds)
## filter <- HTSBasicFilter(dds, method="mean", cutoff.type="quantile", 
##	cutoff = 0.4)
## res <- results(filter, independentFiltering=FALSE)

#' Normalize transcriptome sequencing data.
#' 
#' Normalize count-based measures of transcriptome sequencing data using the
#' Trimmed Means of M-values (TMM) or DESeq approach.
#'
#' @param data numeric matrix representing the counts of dimension (\emph{g} x \emph{n}), 
#' for \emph{g} genes in \emph{n} samples.
#' 
#' @param normalization Normalization method to be used to correct for differences in library sizes, with choices
#' \dQuote{TMM} (Trimmed Mean of M-values), \dQuote{DESeq} (normalization method proposed in the
#'  DESeq package), and \dQuote{none} 
#'
#' @return
#' \itemize{
#'  \item{data.norm }{A numeric matrix representing the normalized counts of dimension (\emph{g} x \emph{n}), 
#'  for \emph{g} genes in \emph{n} samples.}
#'  \item{norm.factor }{A vector of length \emph{n} giving the estimated library sizes estimated by the
#'  normalization method specified in \code{normalization}}
#' }
#' 
#' @references 
#' S. Anders and W. Huber (2010). Differential expression analysis for sequence count data.
#' \emph{Genome Biology}, 11(R106):1-28.
#' 
#' A. Rau, M. Gallopin, G. Celeux, F. Jaffrezic (2013). Data-based filtering 
#' for replicated high-throughput transcriptome sequencing experiments. \emph{Bioinformatics}, 
#' doi: 10.1093/bioinformatics/btt350.
#' 
#' M. D. Robinson and A. Oshlack (2010). A scaling normalization method for differential expression
#' analysis of RNA-seq data. \emph{Genome Biology}, 11(R25).
#' 
#' @author Andrea Rau, Melina Gallopin, Gilles Celeux, and Florence Jaffrezic
#' @export
#'
#' @examples
#' library(Biobase)
#' data("sultan")
#' normData <- normalizeData(exprs(sultan), norm="DESeq") 
#' 
#' @keywords methods
#' 
#' @importFrom utils data
#' @importFrom edgeR calcNormFactors
#' @importFrom stats median

normalizeData <-
function(data, normalization) {
	if(normalization == "TMM") {
		N <- colSums(data)
		f <- calcNormFactors(data,method="TMM")
		TMM <- N*f / mean(N*f)
		norm.factor <- TMM
		data.norm <- scale(data, center=FALSE, scale=TMM)


	}
	if(normalization == "DESeq") {
		## Code taken from DESeq (v1.8.3)
		## estimateSizeFactorsForMatrix() function:
    		loggeomeans <- rowMeans(log(data))
   		deseq <- apply(data, 2, function(cnts) exp(median((log(cnts) - 
       			loggeomeans)[is.finite(loggeomeans)])))
		norm.factor <- deseq
		data.norm <- scale(data, center=FALSE, scale=deseq)
	}
	if(normalization == "none") {
		data.norm <- data
		norm.factor <- NA
	}
	return(list(data.norm = data.norm, norm.factor = norm.factor))
}

## ----fig.align = "center", echo=FALSE-----------------------------------------
options(rmarkdown.html_vignette.check_title = FALSE)

## ----loadingPackages, message=FALSE, fig.cap="Histogram of log transformed counts from the Sultan data. This illustrates the large number of genes with very small counts as well as the large heterogeneity in counts observed."----
library(HTSFilter)
library(edgeR)
library(DESeq2)
data("sultan")
hist(log(exprs(sultan)+1), col="grey", breaks=25, main="", 
  xlab="Log(counts+1)")
pData(sultan)
dim(sultan)

## ----matrix, fig.cap="Global Jaccard index for the Sultan data. The index is calculated for a variety of threshold values after TMM normalization, with a loess curve (blue line) superposed and data-based threshold values (red cross and red dotted line) equal to 11.764."----
mat <- exprs(sultan)
conds <- as.character(pData(sultan)$cell.line)

## Only 25 tested thresholds to reduce computation time
filter <- HTSFilter(mat, conds, s.min=1, s.max=200, s.len=25)
mat <- filter$filteredData
dim(mat)
dim(filter$removedData)

## ----refilter, fig.cap="HTSFilter on pre-filtered Sultan data. (left) The global Jaccard index on the pre-filtered data is calculated for a variety of threshold values after TMM normalization, with a loess curve (blue line) superposed and data-based threshold values (red cross and red dotted line) equal to 1.64. (right) Histogram of the re-filtered data after applying HTSFilter."----
par(mfrow = c(1,2), mar = c(4,4,2,2))
filter.2 <- HTSFilter(mat, conds, s.len=25)
dim(filter.2$removedData)
hist(log(filter.2$filteredData+1), col="grey", breaks=25, main="", 
  xlab="Log(counts+1)")

## ----dge----------------------------------------------------------------------
dge <- DGEList(counts=exprs(sultan), group=conds)
dge <- calcNormFactors(dge)
dge <- estimateDisp(dge)
et <- exactTest(dge)
et <- HTSFilter(et, DGEList=dge, s.len=25, plot=FALSE)$filteredData
dim(et)
class(et)
topTags(et)

## ----dgetoptags---------------------------------------------------------------
topTags(et)

## ----dge2---------------------------------------------------------------------
design <- model.matrix(~conds)
dge <- DGEList(counts=exprs(sultan), group=conds)
dge <- calcNormFactors(dge)
dge <- estimateDisp(dge, design)
fit <- glmFit(dge,design)
lrt <- glmLRT(fit,coef=2)
lrt <- HTSFilter(lrt, DGEGLM=fit, s.len=25, plot=FALSE)$filteredData
dim(lrt)
class(lrt)

## ----dge2toptags--------------------------------------------------------------
topTags(lrt)

## ----cds2---------------------------------------------------------------------
conds <- gsub(" ", ".", conds)
dds <- DESeqDataSetFromMatrix(countData = exprs(sultan),
                              colData = data.frame(cell.line = factor(conds)),
                              design = ~ cell.line)
dds <- DESeq(dds)
filter <- HTSFilter(dds, s.len=25, plot=FALSE)$filteredData
class(filter)
dim(filter)
res <- results(filter, independentFiltering=FALSE)
head(res)

## ----ses2, eval=FALSE---------------------------------------------------------
# library(EDASeq)
# ses <- newSeqExpressionSet(exprs(sultan),
#        phenoData=pData(sultan))
# ses.norm <- betweenLaneNormalization(ses, which="full")

## ----ses3, eval=FALSE---------------------------------------------------------
# filter <- HTSFilter(counts(ses.norm), conds, s.len=25, norm="none",
#           plot=FALSE)
# head(filter$on)
# table(filter$on)

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

context("Matrix test")

## Check that conditions are a vector
  mat <- matrix(NA, nrow=100, ncol=10)
  conds <- matrix(NA, nrow=10, ncol=1)
  expect_error(HTSFilter(mat, conds))

test_that("data.frame test", {
  expect_that(10, equals(10))
  expect_that(11, equals(11))
})

---
title: "*HTSFilter* package: Quick-start guide"
author: 
- name: Andrea Rau
  affiliation: INRAE
  email: andrea.rau@inrae.fr
- name: Mélina Gallopin
- name: Gilles Celeux
- name: Florence Jaffrézic
package: HTSFilter
date: "`r Sys.Date()`"
bibliography: vignette_refs.bib
output: 
  BiocStyle::html_document:
    toc_float: true
  BiocStyle::pdf_document: default
vignette: >
  %\VignetteIndexEntry{HTSFilter}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---


```{r, fig.align = "center", echo=FALSE}
options(rmarkdown.html_vignette.check_title = FALSE)
```

This vignette illustrates the use of the *HTSFilter* package to filter 
replicated data from transcriptome sequencing experiments (e.g., RNA sequencing 
data) for a variety of different data classes: `matrix`, 
`data.frame`, the S3 classes associated with the *edgeR* package (`DGEExact`
and `DGELRT`), and the S4 class associated with the *DESeq2* package 
(`DESeqDataSet`). 

# Introduction
 
High-throughput sequencing (HTS) data, such as RNA-sequencing (RNA-seq) data, 
are increasingly used to conduct differential analyses, in which statistical 
tests are performed for each biological feature (e.g., a gene, transcript, exon) 
in order to identify those whose expression levels show systematic covariation 
with a particular condition, such as a treatment or phenotype of interest. 
For the remainder of this vignette, we will focus on gene-level differential 
analyses, although these methods may also be applied to differential analyses 
of (count-based measures of) transcript- or exon-level expression.

Because hypothesis tests are performed for gene-by-gene differential analyses,
the obtained $p$-values must be adjusted to correct for multiple testing. 
However, procedures to adjust $p$-values to control the number of detected 
false positives often lead to a loss of power to detect truly differentially 
expressed (DE) genes due to the large number of hypothesis tests performed. 
To reduce the impact of such procedures, independent data filters are often 
used to identify and remove genes that appear to generate an uninformative 
signal [@Bourgon2010]; this in turn moderates the correction needed to adjust 
for multiple testing. For independent filtering methods for microarray data,
see for example the 
[*genefilter*](https://bioconductor.org/packages/release/bioc/html/genefilter.html) 
Bioconductor package [@Gentleman].

The *HTSFilter* package implements a novel data-based filtering procedure 
based on the calculation of a similarity index among biological replicates 
for read counts arising from replicated transcriptome sequencing (RNA-seq)
data. This technique provides an intuitive data-driven way to filter 
high-throughput transcriptome sequencing data and to effectively remove genes
with low, constant expression levels without incorrectly removing those that 
would otherwise have been identified as DE. The two fundamental assumptions of 
the filter implemented in the *HTSFilter* package are as follows:  

* Biological replicates are present for each experimental condition, and
* Data can be appropriately normalized (scaled) to correct for systematic 
inter-sample biases.

Assuming these conditions hold, *HTSFilter* implements a method to identify a 
filtering threshold that maximizes the *filtering similarity* among replicates, 
that is, one where most genes tend to either have normalized counts less than 
or equal to the cutoff in all samples (i.e., filtered genes) or greater than 
the cutoff in all samples (i.e., non-filtered genes). This filtering similarity 
is defined using the global Jaccard index, that is, the average Jaccard index
calculated between pairs of replicates within each experimental condition; 
see @Rau2012a for more details.

For more information about between-sample normalization strategies, see 
@Dillies2012; in particular, strategies for normalizing data with differences 
in library size and composition may be found in @Anders2010 and @Robinson2010, 
and strategies for normalizing data exhibiting sample-specific biases due to 
GC content may be found in @Risso2011 and @Hansen2012. Within the *HTSFilter*
package, the Trimmed Means of M-values (TMM) [@Robinson2010] and DESeq 
[@Anders2010] normalization strategies may be used prior to calculating an 
appropriate data-based filter. If an alternative normalization strategy is 
needed or desired, the normalization may be applied prior to filtering the 
data with `normalization="none" `in the `HTSFilter` function; 
see Section \@ref(edaseqnorm) for an example.

The *HTSFilter* package is able to accommodate unnormalized or normalized 
replicated count data in the form of a `matrix` or `data.frame` (in which each 
row corresponds to a biological feature and each column to a biological 
sample), one of the S3 classes associated with the *edgeR* package (`DGEList`, 
`DGEExact`, `DGEGLM`, and `DGELRT`), or `DESeqDataSet` (the S4 class associated 
with the *DESeq2* package), as illustrated in the following sections.

Finally, we note that the filtering method implemented in the *HTSFilter* 
package is designed to filter transcriptome sequencing, and not microarray, 
data; in particular, the proposed filter is effective for data with features 
that take on values over a large order of magnitude and with a subset of 
features exhibiting small levels of expression across samples (see, for example, 
Figure \@ref(fig:loadingPackages)). In this vignette, we illustrate its use on 
count-based measures of gene expression, although its use is not strictly 
limited to discrete data.

# Input data

For the purposes of this vignette, we make use of data from a study of 
sex-specific expression of liver cells in human and the *DESeq2* and *edgeR* 
packages for differential analysis. @Sultan2008 obtained a high-throughput 
sequencing data (using a 1G Illumina Genome Analyzer sequencing machine) from a 
human embryonic kidney and a B cell line, with two biological replicates each. 
The raw read counts and phenotype tables were obtained from the ReCount online 
resource [@Frazee2011].

To begin, we load the *HTSFilter* package, attach the gene-level count 
data contained in `sultan`, and take a quick look at a histrogram of gene counts:

```{r loadingPackages, message=FALSE, fig.cap="Histogram of log transformed counts from the Sultan data. This illustrates the large number of genes with very small counts as well as the large heterogeneity in counts observed."}
library(HTSFilter)
library(edgeR)
library(DESeq2)
data("sultan")
hist(log(exprs(sultan)+1), col="grey", breaks=25, main="", 
  xlab="Log(counts+1)")
pData(sultan)
dim(sultan)
```

The unfiltered data contain 9010 genes in four samples (two replicates per 
condition).


# Use of *HTSFilter* with varying data types

## `matrix` and `data.frame` classes

To filter high-throughput sequencing data in the form of a `matrix` or 
`data.frame`, we first access the expression data, contained in `exprs(sultan)`,
and create a vector identifying the condition labels for each of the samples 
via the `pData` *Biobase* function. We then filter the data using the 
`HTSFilter` function, specifying that the number of tested thresholds be only 25 
(`s.len=25`) rather than the default value of 100 to reduce computation time 
for this example. Note that as it is unspecified, the default normalization
method is used for filtering the data, namely the Trimmed Mean of M-values 
(TMM) method of @Robinson2010. To use the DESeq normalization method 
[@Anders2010] `normalization="DESeq"` may be specified.

```{r matrix, fig.cap="Global Jaccard index for the Sultan data. The index is calculated for a variety of threshold values after TMM normalization, with a loess curve (blue line) superposed and data-based threshold values (red cross and red dotted line) equal to 11.764."}
mat <- exprs(sultan)
conds <- as.character(pData(sultan)$cell.line)

## Only 25 tested thresholds to reduce computation time
filter <- HTSFilter(mat, conds, s.min=1, s.max=200, s.len=25)
mat <- filter$filteredData
dim(mat)
dim(filter$removedData)
```

For this example, we find a data-based threshold equal to 11.764; genes with 
normalized values less than this threshold in all samples are filtered from
subsequent analyses. The proposed filter thus removes 4015 genes from further
analyses, leaving 4995 genes. 

We note that an important part of the filter proposed in the *HTSFilter* 
package is a check of the behavior of the global similarity index calculated 
over a range of threshold values, and in particular, to verify that a 
reasonable maximum value is reached for the global similarity index over the 
range of tested threshold values (see Figure \@ref(fig:matrix)); the maximum 
possible value for the global Jaccard index is nearly 1. To illustrate the 
importance of this check, we attempt to re-apply the proposed filter to the
previously filtered data (in practice, of course, this would be nonsensical):


```{r refilter, fig.cap="HTSFilter on pre-filtered Sultan data. (left) The global Jaccard index on the pre-filtered data is calculated for a variety of threshold values after TMM normalization, with a loess curve (blue line) superposed and data-based threshold values (red cross and red dotted line) equal to 1.64. (right) Histogram of the re-filtered data after applying HTSFilter."}
par(mfrow = c(1,2), mar = c(4,4,2,2))
filter.2 <- HTSFilter(mat, conds, s.len=25)
dim(filter.2$removedData)
hist(log(filter.2$filteredData+1), col="grey", breaks=25, main="", 
  xlab="Log(counts+1)")
```

In the lefthand panel of Figure \@ref(fig:refilter), we note a plateau of large
global Jaccard index values for thresholds less than 2, with a decrease 
thereafter; this corresponds to filtering no genes, unsurprising given that 
genes with low, constant levels of expression have already been filtered from 
the analysis (see the righthand panel of Figure \@ref(fig:refilter)).



## *edgeR* package pipeline

We next illustrate the use of *HTSFilter* within the *edgeR* pipeline 
for differential analysis (S3 classes `DGEList`, `DGEExact`, `DGEGLM`, or 
`DGELRT`). For the purposes of this vignette, we will consider the S3 classes 
`DGEExact` and `DGELRT`. The former is the class containing the results of the 
differential expression analysis between two groups of count libraries 
(resulting from a call to the function `exactTest` in *edgeR*); the latter is 
the class containing the results of a generalized linear model (GLM)-based 
differential analysis (resulting from a call to the function `glmLRT` in 
*edgeR*). Although the filter may be applied earlier in the *edgeR*
pipeline (i.e., to objects of class `DGEList` or `DGEGLM`), we do not 
recommend doing so, as parameter estimation makes use of counts adjusted 
using a quantile-to-quantile method (pseudo-counts).

### S3 class `DGEExact`

We first coerce the data into the appropriate class with the function 
`DGEList`, where the `group` variable is set to contain a vector of 
condition labels for each of the samples. Next, after calculating normalizing 
factors to scale library sizes (`calcNormFactors`), we estimate common and 
tagwise dispersion parameters using `estimateDisp` (using the quantile 
conditional likelihood for each gene) and obtain differential analysis 
results using `exactTest`. Finally, we apply the filter using the `HTSFilter` 
function, again specifying that the number of tested thresholds be only 25 
(`s.len=25`) rather than the default value of 100. Note that as it is 
unspecified, the default normalization method is used for filtering the data, 
namely the Trimmed Mean of M-values (TMM) method [@Robinson2010]; alternative 
normalization, including `"pseudo.counts"` for the quantile-to-quantile 
adjusted counts used for parameter estimation, may also be specified.
We suppress the plot of the global Jaccard index below using 
`plot = FALSE`, as it is identical to that shown in Figure \@ref(fig:matrix).

```{r dge}
dge <- DGEList(counts=exprs(sultan), group=conds)
dge <- calcNormFactors(dge)
dge <- estimateDisp(dge)
et <- exactTest(dge)
et <- HTSFilter(et, DGEList=dge, s.len=25, plot=FALSE)$filteredData
dim(et)
class(et)
topTags(et)
```

Note that the filtered data are of the class `DGEExact`, allowing for a call
to the `topTags` function. 

```{r dgetoptags}
topTags(et)
```

### S3 class `DGELRT`

We follow the same steps as the previous example, where the `estimateDisp`
function is now used to obtain per-gene dispersion parameter estimates using 
the adjusted profile loglikelihood, the `glmFit` function is used to fit a 
negative binomial generalized log-linear model to the read counts for each 
gene, and the `glmLRT` function is used to conduct likelihood ratio tests for 
one or more coefficients in the GLM. The output of `glmLRT` is an S3 object of 
class `DGELRT` and contains the GLM differential analysis results.
As before, we apply the filter using the `HTSFilter` function, again
suppressing the plot of the global Jaccard index using \Rcode{plot = FALSE}, 
as it is identical to that shown in Figure \@ref(fig:matrix).

```{r dge2}
design <- model.matrix(~conds)
dge <- DGEList(counts=exprs(sultan), group=conds)
dge <- calcNormFactors(dge)
dge <- estimateDisp(dge, design)
fit <- glmFit(dge,design)
lrt <- glmLRT(fit,coef=2)
lrt <- HTSFilter(lrt, DGEGLM=fit, s.len=25, plot=FALSE)$filteredData
dim(lrt)
class(lrt)
```

Note that the filtered data are of the class `DGEList`, allowing for a call 
to the `topTags` function.

```{r dge2toptags}
topTags(lrt)
```


## *DESeq2* package pipeline: S4 class `DESeqDataSet`}

The *HTSFilter* package allows for a straightforward integration within the 
*DESeq2* analysis pipeline, most notably allowing for $p$-values to be 
adjusted only for those genes passing the filter. Note that *DESeq2* now 
implements an independent filtering procedure by default in the `results` 
function; this filter is a potential alternative filtering technique and does 
not need to be used in addition to the one included in *HTSFilter*. In fact, 
each filter is targeting the same weakly expressed genes to be filtered from 
the analysis. As such, if the user wishes to make use of *HTSFilter* within 
the *DESeq2* pipeline, the argument `independentFiltering=FALSE` should be 
used when calling the `results` function in *DESeq2*.

To illustrate the application of a filter for high-throughput sequencing data 
in the form of a `DESeqDataSet` (the class used within the *DESeq2* pipeline 
for differential analysis), we coerce `sultan` into an object of the class 
`DESeqDataSet` using the function `DESeqDataSetFromMatrix`. Once again, 
we specify that the number of tested thresholds be only 25 (`s.len=25`)
rather than the default value of 100 to reduce computation time. 
or objects in the form of a `DESeqDataSet`, the default normalization 
strategy is `"DESeq"`, although alternative normalization strategies may also 
be used. Note that below we replace the spaces in condition names with "." 
prior to creating a `"DESeqDataSet"` object.

```{r cds2}
conds <- gsub(" ", ".", conds)
dds <- DESeqDataSetFromMatrix(countData = exprs(sultan),
                              colData = data.frame(cell.line = factor(conds)),
                              design = ~ cell.line)
dds <- DESeq(dds)
filter <- HTSFilter(dds, s.len=25, plot=FALSE)$filteredData
class(filter)
dim(filter)
res <- results(filter, independentFiltering=FALSE)
head(res)
```

The filtered data remain an object of class `DESeqDataSet`, and subsequent 
functions from *DESeq2* (such as the results summary function \Rcode{results})
may be called directly upon it.

# Alternative normalization using *EDAseq* {#edaseqnorm}

As a final example, we illustrate the use of the *HTSFilter* package with an 
alternative normalization strategy, namely the full quantile normalization 
method in the *EDAseq* package; such a step may be useful when the TMM or 
DESeq normalization methods are not appropriate for a given dataset. Once 
again, we create a new object of the appropriate class with the function 
`newSeqExpressionSet` and normalize data using the `betweenLaneNormalization`
function (with `which="full"`) in *EDAseq*.

```{r ses2, eval=FALSE}
library(EDASeq)
ses <- newSeqExpressionSet(exprs(sultan), 
       phenoData=pData(sultan))
ses.norm <- betweenLaneNormalization(ses, which="full")
```

Subsequently, `HTSFilter` is applied to the normalized data (again using 
`s.len=25`), and the normalization method is set to `norm="none"`. We may then 
make use of the `on` vector in the results, which identifies filtered and 
unfiltered genes (respectively) with 0 and 1, to identify rows in the original 
data matrix to be retained.

```{r ses3, eval=FALSE}
filter <- HTSFilter(counts(ses.norm), conds, s.len=25, norm="none", 
          plot=FALSE)
head(filter$on)
table(filter$on)
```

# Session Info

```{r sessionInfo}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HTSFilter_package.R
\docType{package}
\name{HTSFilter-package}
\alias{HTSFilter-package}
\title{Filter replicated high-throughput transcriptome sequencing data}
\description{
This package implements a filtering procedure for replicated
transcriptome sequencing data based on a global Jaccard similarity index in
order to identify genes with low, constant levels of expression across one or
more experimental conditions.
}
\details{
\tabular{ll}{ Package: \tab HTSFilter\cr Type: \tab Package\cr Version:
\tab 1.31.1\cr Date: \tab 2020-11-26\cr License: \tab Artistic-2.0 \cr LazyLoad:
\tab yes\cr }
}
\examples{
library(Biobase)
data("sultan")
conds <- pData(sultan)$cell.line

########################################################################
## Matrix or data.frame
########################################################################

filter <- HTSFilter(exprs(sultan), conds, s.len=25, plot=FALSE)

########################################################################
## DGEExact
########################################################################

library(edgeR)
dge <- DGEList(counts=exprs(sultan), group=conds)
dge <- calcNormFactors(dge)
dge <- estimateCommonDisp(dge)
dge <- estimateTagwiseDisp(dge)
et <- exactTest(dge)
et <- HTSFilter(et, DGEList=dge, s.len=25, plot=FALSE)$filteredData
## topTags(et)


########################################################################
## DESeq2
########################################################################

library(DESeq2)
conds <- gsub(" ", ".", conds)
dds <- DESeqDataSetFromMatrix(countData = exprs(sultan),
                              colData = data.frame(cell.line = conds),
                              design = ~ cell.line)
## Not run:
##
## dds <- DESeq(dds)
## filter <- HTSFilter(dds, s.len=25, plot=FALSE)$filteredData
## class(filter)
## res <- results(filter, independentFiltering=FALSE)
}
\references{
R. Bourgon, R. Gentleman, and W. Huber. (2010) Independent filtering increases detection power for high-
throughput experiments. \emph{PNAS} \bold{107}(21):9546-9551.

P. Jaccard (1901). Etude comparative de la distribution
orale dans une portion des Alpes et des Jura.
\emph{Bulletin de la Societe Vaudoise des Sciences Naturelles}, \bold{37}:547-549.

A. Rau, M. Gallopin, G. Celeux, F. Jaffrezic (2013). Data-based filtering
for replicated high-throughput transcriptome sequencing experiments. \emph{Bioinformatics},
doi: 10.1093/bioinformatics/btt350.
}
\author{
Andrea Rau, Melina Gallopin, Gilles Celeux, and Florence Jaffrezic

Maintainer: Andrea Rau <\url{andrea.rau@inrae.fr}>
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HTSFilter_package.R
\docType{data}
\name{sultan}
\alias{sultan}
\title{RNA-seq data from humans in Sultan et al. (2008)}
\format{
An ExpressionSet named \code{sultan.eset} containing the phenotype data and
expression data for the Sultan et al. (2008) experiment. Phenotype data may be
accessed using the \code{pData} function, and expression data may be accessed
using the \code{exprs} function.
}
\source{
ReCount online resource (http://bowtie-bio.sourceforge.net/recount).
}
\usage{
data(sultan)
}
\value{
Object of class \sQuote{ExpressionSet}. Matrix of counts can be accessed after
loading the \sQuote{Biobase} package and calling \code{exprs(sultan))}.
}
\description{
This dataset represents RNA-seq data from humans in two conditions (Ramos B cell line and HEK293T), with two biological replicates per condition.
The ExpressionSet was downloaded from the ReCount online resource.
}
\references{
\url{data_blah.com}

A. C. Frazee, B. Langmead, and J. T. Leek. ReCount: a multi-experiment resource
of analysis-ready RNA-seq gene count datasets. BMC Bioinformatics, 12(449), 2011.

M. Sultan, M. H. Schulz, H. Richard, A. Magen, A. Klingenhoff, M. Scherf, M. Seifert,
T. Borodina, A. Soldatov, D. Parkhomchuk, D. Schmidt, S. O'Keefe, S. Haas,
M. Vingron, H. Lehrach, and M. L. Yaspo. A global view of gene activity and alternative
splicing by deep sequencing of the human transcriptome. Science, 15(5891):956-60, 2008.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HTSFilter-methods.R
\name{HTSFilter}
\alias{HTSFilter}
\alias{HTSFilter-methods}
\alias{HTSFilter,matrix-method}
\alias{HTSFilter,data.frame-method}
\alias{HTSFilter,DGEList-method}
\alias{HTSFilter,DGEExact-method}
\alias{HTSFilter,DGEGLM-method}
\alias{HTSFilter,DGELRT-method}
\alias{HTSFilter,DESeqDataSet-method}
\title{Calculate data-based filtering threshold for replicated transcriptome sequencing data.}
\usage{
HTSFilter(x, ...)

\S4method{HTSFilter}{matrix}(
  x,
  conds,
  s.min = 1,
  s.max = 200,
  s.len = 100,
  loess.span = 0.3,
  normalization = c("TMM", "DESeq", "none"),
  plot = TRUE,
  plot.name = NA,
  parallel = FALSE,
  BPPARAM = bpparam()
)

\S4method{HTSFilter}{data.frame}(
  x,
  conds,
  s.min = 1,
  s.max = 200,
  s.len = 100,
  loess.span = 0.3,
  normalization = c("TMM", "DESeq", "none"),
  plot = TRUE,
  plot.name = NA,
  parallel = FALSE,
  BPPARAM = bpparam()
)

\S4method{HTSFilter}{DGEList}(
  x,
  s.min = 1,
  s.max = 200,
  s.len = 100,
  loess.span = 0.3,
  normalization = c("TMM", "DESeq", "pseudo.counts", "none"),
  plot = TRUE,
  plot.name = NA,
  parallel = FALSE,
  BPPARAM = bpparam(),
  conds
)

\S4method{HTSFilter}{DGEExact}(
  x,
  DGEList,
  s.min = 1,
  s.max = 200,
  s.len = 100,
  loess.span = 0.3,
  normalization = c("TMM", "DESeq", "pseudo.counts", "none"),
  plot = TRUE,
  plot.name = NA,
  parallel = FALSE,
  BPPARAM = bpparam(),
  conds
)

\S4method{HTSFilter}{DGEGLM}(
  x,
  s.min = 1,
  s.max = 200,
  s.len = 100,
  loess.span = 0.3,
  normalization = c("TMM", "DESeq", "none"),
  plot = TRUE,
  plot.name = NA,
  parallel = FALSE,
  BPPARAM = bpparam(),
  conds
)

\S4method{HTSFilter}{DGELRT}(
  x,
  DGEGLM,
  s.min = 1,
  s.max = 200,
  s.len = 100,
  loess.span = 0.3,
  normalization = c("TMM", "DESeq", "none"),
  plot = TRUE,
  plot.name = NA,
  parallel = FALSE,
  BPPARAM = bpparam(),
  conds
)

\S4method{HTSFilter}{DESeqDataSet}(
  x,
  s.min = 1,
  s.max = 200,
  s.len = 100,
  loess.span = 0.3,
  normalization = c("DESeq", "TMM", "none"),
  plot = TRUE,
  plot.name = NA,
  pAdjustMethod = "BH",
  parallel = FALSE,
  BPPARAM = bpparam(),
  conds
)
}
\arguments{
\item{x}{A numeric matrix or data.frame representing the counts of dimension (\emph{g} x \emph{n}),
for \emph{g} genes in \emph{n} samples, a \code{DGEList} object, a
\code{DGEExact} object, a \code{DGEGLM} object, a \code{DGELRT} object, or a \code{DESeqDataSet} object.}

\item{...}{Additional optional arguments}

\item{conds}{Vector of length \emph{n} identifying the experimental condition of each of the \emph{n} samples; required when sQuote(x)
is a numeric matrix. In the case of objects of class \code{DGEList},
\code{DGEExact}, \code{DGEGLM}, \code{DGELRT}, or \code{DESeqDataSet}, the design matrix is automatically}

\item{s.min}{Minimum value of filtering threshold to be considered, with default value equal to 1}

\item{s.max}{Maximum value of filtering threshold to be considered, with default value equal to 200}

\item{s.len}{Length of sequence of filtering thresholds to be considered (from \code{s.min} to \code{s.max})
for the calculation of the global similarity index}

\item{loess.span}{Span of the loess curve to be fitted to the filtering thresholds and corresponding global similarity
indices, with default value equal to 0.3}

\item{normalization}{Normalization method to be used to correct for differences in library sizes, with
choices  \dQuote{TMM} (Trimmed Mean of M-values), \dQuote{DESeq} (normalization method proposed in the
DESeq package), \dQuote{pseudo.counts} (pseudo-counts obtained via quantile-quantile normalization in
the edgeR package, only available for objects of class \code{DGEList} and \code{DGEExact}), and
\dQuote{none} (to be used only if user is certain no normalization is required, or if data have already
been pre-normalized by an alternative method)}

\item{plot}{If \dQuote{TRUE}, produce a plot of the calculated global similarity indices against the
filtering threshold with superimposed loess curve}

\item{plot.name}{If \code{plot} = \dQuote{TRUE}, the name of the PDF file to be saved to the current working directory.
If \code{plot.name} = NA, the plot is drawn in the current window.}

\item{parallel}{If \code{FALSE}, no parallelization. If \code{TRUE}, parallel
execution using BiocParallel (see next argument \code{BPPARAM}). A note on running
in parallel using BiocParallel: it may be advantageous to remove large, unneeded objects
from the current R environment before calling the function, as it is possible that R's
internal garbage collection will copy these files while running on worker nodes.}

\item{BPPARAM}{Optional parameter object passed internally to \code{bplapply} when
\code{parallel=TRUE}. If not specified, the parameters last registered with \code{register}
will be used.}

\item{DGEList}{Object of class DGEList, to be used when filtering objects of class DGEExact}

\item{DGEGLM}{Object of class DGEGLM, to be used when filtering objects of class DGELRT}

\item{pAdjustMethod}{The method used to adjust p-values, see \code{?p.adjust}}
}
\value{
\itemize{
 \item{filteredData }{An object of the same class as \code{x} containing the data that passed the filter}

 \item{on }{A binary vector of length \emph{g}, where 1 indicates a gene with normalized expression
  greater than the optimal filtering threshold \code{s.optimal} in at least one sample (irrespective of
  condition labels), and 0 indicates a gene with normalized expression less than or equal to the optimal
  filtering threshold in all samples}

 \item{s }{The optimal filtering threshold as identified by the global similarity index}

 \item{indexValues }{A matrix of dimension (\code{s.len} x 2) giving the tested filtering thersholds and the
 corresponding global similarity indices. Note that the threshold values are equally spaced on the \emph{log}
 scale, and thus unequally spaced on the count scale (i.e., we test more threshold values at very low levels
 of expression, and fewer at very high levels of expression).}

 \item{normFactor }{A vector of length \emph{n} giving the estimated library sizes estimated by the
  normalization method specified in \code{normalization}}

 \item{removedData }{A matrix containing the filtered data}
}
}
\description{
Calculate a data-based filtering threshold for replicated transcriptome
sequencing data through the pairwise Jaccard similarity index between pairs
of replicates within each experimental condition.
}
\details{
The Jaccard similarity index, which measures the overlap of two sets, is calculated as follows.
Given two binary vectors, each of length \emph{n}, we define the following values:
  \itemize{
      \item \emph{a} = the number of attributes with a value of 1 in both vectors
      \item \emph{b} = the number of attributes with a value of 1 in the first vector and 0 in the second
      \item \emph{c} = the number of attributes with a value of 0 in the first vector and 1 in the second
      \item \emph{d} = the number of attributes with a value of 0 in both vectors
        }
We note that all attributes fall into one of these four quantities, so \eqn{a+b+c+d=n}. Given these
quantities, we may calculate the Jaccard similarity index between the two vectors as follows:
  \deqn{J = \frac{a}{a+b+c}.}{J = a/(a+b+c).}
}
\examples{
library(Biobase)
data("sultan")
conds <- pData(sultan)$cell.line

########################################################################
## Matrix or data.frame
########################################################################

filter <- HTSFilter(exprs(sultan), conds, s.len=25, plot=FALSE)

########################################################################
## DGEExact
########################################################################

library(edgeR)
dge <- DGEList(counts=exprs(sultan), group=conds)
dge <- calcNormFactors(dge)
dge <- estimateCommonDisp(dge)
dge <- estimateTagwiseDisp(dge)
et <- exactTest(dge)
et <- HTSFilter(et, DGEList=dge, s.len=25, plot=FALSE)$filteredData
## topTags(et)


########################################################################
## DESeq2
########################################################################

library(DESeq2)
conds <- gsub(" ", ".", conds)
dds <- DESeqDataSetFromMatrix(countData = exprs(sultan),
                              colData = data.frame(cell.line = conds),
                              design = ~ cell.line)
## Not run:
##
## dds <- DESeq(dds)
## filter <- HTSFilter(dds, s.len=25, plot=FALSE)$filteredData
## class(filter)
## res <- results(filter, independentFiltering=FALSE)
}
\references{
R. Bourgon, R. Gentleman, and W. Huber. (2010) Independent filtering increases detection power for high-
throughput experiments. \emph{PNAS} \bold{107}(21):9546-9551.

P. Jaccard (1901). Etude comparative de la distribution
orale dans une portion des Alpes et des Jura.
\emph{Bulletin de la Societe Vaudoise des Sciences Naturelles}, \bold{37}:547-549.

A. Rau, M. Gallopin, G. Celeux, F. Jaffrezic (2013). Data-based filtering
for replicated high-throughput transcriptome sequencing experiments. \emph{Bioinformatics},
doi: 10.1093/bioinformatics/btt350.
}
\author{
Andrea Rau, Melina Gallopin, Gilles Celeux, and Florence Jaffrezic
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normalizeData.R
\name{normalizeData}
\alias{normalizeData}
\title{Normalize transcriptome sequencing data.}
\usage{
normalizeData(data, normalization)
}
\arguments{
\item{data}{numeric matrix representing the counts of dimension (\emph{g} x \emph{n}), 
for \emph{g} genes in \emph{n} samples.}

\item{normalization}{Normalization method to be used to correct for differences in library sizes, with choices
\dQuote{TMM} (Trimmed Mean of M-values), \dQuote{DESeq} (normalization method proposed in the
 DESeq package), and \dQuote{none}}
}
\value{
\itemize{
 \item{data.norm }{A numeric matrix representing the normalized counts of dimension (\emph{g} x \emph{n}), 
 for \emph{g} genes in \emph{n} samples.}
 \item{norm.factor }{A vector of length \emph{n} giving the estimated library sizes estimated by the
 normalization method specified in \code{normalization}}
}
}
\description{
Normalize count-based measures of transcriptome sequencing data using the
Trimmed Means of M-values (TMM) or DESeq approach.
}
\examples{
library(Biobase)
data("sultan")
normData <- normalizeData(exprs(sultan), norm="DESeq") 

}
\references{
S. Anders and W. Huber (2010). Differential expression analysis for sequence count data.
\emph{Genome Biology}, 11(R106):1-28.

A. Rau, M. Gallopin, G. Celeux, F. Jaffrezic (2013). Data-based filtering 
for replicated high-throughput transcriptome sequencing experiments. \emph{Bioinformatics}, 
doi: 10.1093/bioinformatics/btt350.

M. D. Robinson and A. Oshlack (2010). A scaling normalization method for differential expression
analysis of RNA-seq data. \emph{Genome Biology}, 11(R25).
}
\author{
Andrea Rau, Melina Gallopin, Gilles Celeux, and Florence Jaffrezic
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HTSBasicFilter-methods.R
\name{HTSBasicFilter}
\alias{HTSBasicFilter}
\alias{HTSBasicFilter,matrix-method}
\alias{HTSBasicFilter,data.frame-method}
\alias{HTSBasicFilter,DGEList-method}
\alias{HTSBasicFilter,DGEExact-method}
\alias{HTSBasicFilter,DGEGLM-method}
\alias{HTSBasicFilter,DGELRT-method}
\alias{HTSBasicFilter,DESeqDataSet-method}
\title{Implement basic filters for transcriptome sequencing data.}
\usage{
HTSBasicFilter(x, ...)

\S4method{HTSBasicFilter}{matrix}(
  x,
  method,
  cutoff.type = "value",
  cutoff = 10,
  length = NA,
  normalization = c("TMM", "DESeq", "none")
)

\S4method{HTSBasicFilter}{data.frame}(
  x,
  method,
  cutoff.type = "value",
  cutoff = 10,
  length = NA,
  normalization = c("TMM", "DESeq", "none")
)

\S4method{HTSBasicFilter}{DGEList}(
  x,
  method,
  cutoff.type = "value",
  cutoff = 10,
  length = NA,
  normalization = c("TMM", "DESeq", "pseudo.counts", "none")
)

\S4method{HTSBasicFilter}{DGEExact}(
  x,
  method,
  cutoff.type = "value",
  cutoff = 10,
  length = NA,
  normalization = c("TMM", "DESeq", "pseudo.counts", "none")
)

\S4method{HTSBasicFilter}{DGEGLM}(
  x,
  method,
  cutoff.type = "value",
  cutoff = 10,
  length = NA,
  normalization = c("TMM", "DESeq", "none")
)

\S4method{HTSBasicFilter}{DGELRT}(
  x,
  method,
  cutoff.type = "value",
  cutoff = 10,
  length = NA,
  normalization = c("TMM", "DESeq", "none")
)

\S4method{HTSBasicFilter}{DESeqDataSet}(
  x,
  method,
  cutoff.type = "value",
  cutoff = 10,
  length = NA,
  normalization = c("DESeq", "TMM", "none"),
  pAdjustMethod = "BH"
)
}
\arguments{
\item{x}{A numeric matrix or data.frame representing the counts of dimension (\emph{g} x \emph{n}), 
for \emph{g} genes in \emph{n} samples, a \code{DGEList} object, a 
\code{DGEExact} object, a \code{DGEGLM} object, a \code{DGELRT} object, or a \code{DESeqDataSet} object.}

\item{...}{Additional optional arguments}

\item{method}{Basic filtering method to be used: \dQuote{mean}, \dQuote{sum}, \dQuote{rpkm}, 
\dQuote{variance}, \dQuote{cpm}, \dQuote{max}, \dQuote{cpm.mean}, \dQuote{cpm.sum}, \dQuote{cpm.variance}, 
\dQuote{cpm.max}, \dQuote{rpkm.mean}, \dQuote{rpkm.sum}, \dQuote{rpkm.variance}, or \dQuote{rpkm.max}}

\item{cutoff.type}{Type of cutoff to be used: a numeric value indicating the number of samples to be 
used for filtering (when \code{method} = \dQuote{cpm} or \dQuote{rpkm}), or one of \dQuote{value}, 
\dQuote{number}, or \dQuote{quantile}}

\item{cutoff}{Cutoff to be used for chosen filter}

\item{length}{Optional vector of length \emph{n} containing the lengths of each gene in \code{x}; 
optional except in the case of \code{method} = \dQuote{rpkm}}

\item{normalization}{Normalization method to be used to correct for differences in library sizes, with 
choices  \dQuote{TMM} (Trimmed Mean of M-values), \dQuote{DESeq} (normalization method proposed in the
DESeq package), \dQuote{pseudo.counts} (pseudo-counts obtained via quantile-quantile normalization in 
the edgeR package, only available for objects of class \code{DGEList} and \code{DGEExact}), and 
\dQuote{none} (to be used only if user is certain no normalization is required, or if data have already 
been pre-normalized by an alternative method)}

\item{pAdjustMethod}{The method used to adjust p-values, see \code{?p.adjust}}
}
\value{
\itemize{
 \item{filteredData }{An object of the same class as \code{x} containing the data that passed the filter}

 \item{on }{A binary vector of length \emph{g}, where 1 indicates a gene with normalized expression
  greater than the optimal filtering threshold \code{s.optimal} in at least one sample (irrespective of 
  condition labels), and 0 indicates a gene with normalized expression less than or equal to the optimal 
  filtering threshold in all samples}

 \item{normFactor }{A vector of length \emph{n} giving the estimated library sizes estimated by the
  normalization method specified in \code{normalization}}

 \item{removedData }{A matrix containing the filtered data}

 \item{filterCrit }{A vector or matrix containing the criteria used to perform filtering}
 }
}
\description{
Implement a variety of basic filters for transcriptome sequencing data.
}
\details{
This function implements a basic filter for high-throughput sequencing data for a variety of filter types: 
mean, sum, RPKM, variance, CPM, maximum, mean CPM values, the sum of CPM values, the variance of CPM 
values, maximum CPM value, mean RPKM values, the sum of RPKM values, the variance of RPKM values, or 
the maximum RPKM value. The filtering criteria used may be for a given cutoff value, a number of genes, 
or a given quantile value.
}
\examples{
library(Biobase)
data("sultan")
conds <- pData(sultan)$cell.line
 
########################################################################
## Matrix or data.frame
########################################################################

## Filter genes with total (sum) normalized gene counts < 10
filter <- HTSBasicFilter(exprs(sultan), method="sum", cutoff.type="value", 
                        cutoff = 10)
                        
                        
########################################################################
## DGEExact
########################################################################

library(edgeR)
## Filter genes with CPM values less than 100 in more than 2 samples
dge <- DGEList(counts=exprs(sultan), group=conds)
dge <- calcNormFactors(dge)
filter <- HTSBasicFilter(dge, method="cpm", cutoff.type=2, cutoff=100)

########################################################################
## DESeq2
########################################################################

library(DESeq2)
conds <- gsub(" ", ".", conds)
dds <- DESeqDataSetFromMatrix(countData = exprs(sultan),
                             colData = data.frame(cell.line = conds),
                               design = ~ cell.line)
                             
                             
## Not run: Filter genes with mean normalized gene counts < 40\% quantile
## dds <- DESeq(dds)
## filter <- HTSBasicFilter(dds, method="mean", cutoff.type="quantile", 
##	cutoff = 0.4)
## res <- results(filter, independentFiltering=FALSE)
}
\references{
R. Bourgon, R. Gentleman, and W. Huber. (2010) Independent filtering increases detection power for high-
throughput experiments. \emph{PNAS} \bold{107}(21):9546-9551.

A. Rau, M. Gallopin, G. Celeux, F. Jaffrezic (2013). Data-based filtering 
for replicated high-throughput transcriptome sequencing experiments. \emph{Bioinformatics},
doi: 10.1093/bioinformatics/btt350.
}
\author{
Andrea Rau, Melina Gallopin, Gilles Celeux, and Florence Jaffrezic
}
\keyword{methods}
